// --------* Variabili Globali (preferenze) *--------
var strbundle;
var dTaTab = false;						// Gestione tab
var dTaOpener = false;					//     "     "
var winFocus = false;					// true quando la finestra è in focus
var isOpenedMessagebox = 0;			// se è attiva una qualche messageBox
var logtext = "";							// logging
var alerting = false;   				// true se è in corso la visualizzazione di un sidebox

pref = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);

function mydump(aMessage) {
  var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
  consoleService.logStringMessage(aMessage);
  logtext = logtext + aMessage + "\n\n";
}

function preferences() {
	this.reduce=true;
	this.alert=false;
	this.askEveryTime = true;
	this.sessionPreference = -1; // la scelta predefinita di salvataggio per la sessione
	this.renaming="";
	this.maxInProgress=3;				// massimo numero di downloads contemporanei
	this.refresh();
	this.saveInTemp=true;
	this.maxChunks=5;
	this.onClosingSaveAborted = true;
	this.onClosingSaveCompleted = true;
	this.onClosingSaveCanceled = true;
}

//--> aggiorna le preferenze
preferences.prototype.refresh = function() {
	this.onClosingSaveAborted = !getPreference("extensions.dta.context.removeaborted", false);
	this.onClosingSaveCompleted = !getPreference("extensions.dta.context.removecompleted", true);
	this.onClosingSaveCanceled = !getPreference("extensions.dta.context.removecanceled", false);
	this.maxInProgress = getPreference("extensions.dta.context.ntask", 3);
	this.reduce = getPreference("extensions.dta.context.reduce", true);
	this.renaming = getPreference("extensions.dta.existing", 3);
	this.saveInTemp = getPreference("extensions.dta.context.saveTemp", true);
	if (findSeparator()=='\\') var alertSupport = true;
	else alertSupport = false;
	/*try {	var temp = Components.classes['@mozilla.org/alerts-service;1'].getService(Components.interfaces.nsIAlertsService); } 
	catch (e) { alertSupport = false; }*/
	this.alert = getPreference("extensions.dta.alertbox", alertSupport?1:0);
	this.maxChunks = getPreference("extensions.dta.context.maxchunks", 5);
	pref.setIntPref("network.http.max-persistent-connections-per-server", this.maxInProgress * this.maxChunks);
}

var Prefs = new preferences();


// --------* Statistiche *--------

function downloadsStruct() {
	this.totalDownloads = 0; 		// numero downloads nella lista
	this.completedDownloads = 0;		// files correttamente salvati
	this.inProgress = 0;					// numero di file in progress (attenzione, incrementato diversamente dall'inProgressList!)
	this.zippedFiles = 0;			  // actual number of compressed files
	this.downloadedBytes = 0;  // per il calcolo della velocità
}

var Stats = new downloadsStruct();

// --------* Lista dei download *--------
function chunk (start, end, relativeEl) {

	this.start = start;
	this.end = end;
	this.relative = relativeEl;
	this.next = -1;
	this.previous = -1;
	this.isComplete = false;
	this.isRunning = false;
	this.chunkSize = 0;
	this.chunkName = "";
	
	this.fileManager=null;
	this.progressPersist=null;
}

function checkFilenames(func, el) {

	mydump("==== " + func + " ====\n.filename="+el.fileName+"\n.destinationName="+el.destinationName+"\n.dirsave="+el.dirSave);
}

function downloadElement(url, name, dir, num, index, desc) {

	this.url = url;
	
	if (dir.substr(dir.length - 1, 1) != findSeparator()) 
		dir += findSeparator();
		
	this.dirSave = dir;				// ha lo slash finale
	this.fileName = name;			
	
	if (name.indexOf("?") > 0) 
		name = name.substring(0, name.indexOf("?")); // = ultima parte di url, eventualmente depurata da caratteri illegali ed argomenti
	
	this.destinationName = toggleInvalidChar(name).replace(/\//g, "");	// per il percorso completo completo, this.dirSave + this.destinationName
	this.contentType = "";
	
	checkFilenames("downloadElement", this);
	
	this.totalSize = 0;
	this.partialSize = 0;
	
	this.compression = false;
	this.listIndex = index;
	this.numIstance = num;
	this.description = desc;
	this.relativeListboxID = "";
	this.alreadyMaskedDir = false;
	this.alreadyMaskedName = false;

	this.isCanceled = false;
	this.isPaused = false;
	this.isCompleted = false;
	this.isResumable = false;
	this.isRunning = false;  // è un download in corso
	this.isStarted = false;
	this.isPassed = false;
	this.isRemoved = false;
	
	this.fileManager=null;
	this.numChunks = 0;
	this.maxChunks = Prefs.maxChunks;
	this.firstChunk = 0;
	
	this.refPage="";
	this.chunks = new Array();
	
	this.timeLastProgress = 0;
	this.timeStart = 0;
	this.order = index;
	this.index = index;
}

downloadElement.prototype.cancelFamily = function() {

	for (var i = 0; i<this.chunks.length; i++) {
	try {
		if (!this.chunks[i].isRunning) 
			if (this.chunks[i].fileManager.exists()) 
				this.chunks[i].fileManager.remove(false);
	} catch (e) {}
	}
}

downloadElement.prototype.setIsComplete = function() {
	mydump("setIsComplete(): totalsize = " + this.totalSize);
	if (this.totalSize == 0) {
		// si cerca di dedurre la completezza dei file con dimensione non conosciuta
		if (this.partialSize != 0 && !this.isRunning && !this.isPaused) 
			this.isCompleted = true;
		else
			this.isCompleted = false;
	} else
		this.isCompleted = (this.partialSize == this.totalSize);
	return this.isCompleted; 
}

downloadElement.prototype.setIsRunning = function() {
	var running = false;
	for (var i = 0; i<this.chunks.length; i++) {
		if(this.chunks[i].isRunning) {
			running = true;
			break;
		}
	}
	this.isRunning = running;
	return running;
}

downloadElement.prototype.setPartialSize = function(){
	var size = 0;
	for (var i = 0; i<this.chunks.length; i++) {
		size = size + this.chunks[i].chunkSize;
	}
	this.partialSize = size;
	return size;
}

downloadElement.prototype.setPaused = function(){
	for (var i = 0; i<this.chunks.length; i++) {
		if (this.chunks[i].isRunning)
			this.chunks[i].progressPersist.cancelSave();
	}
}

function getRemovedNumber() {
	var t = 0;
	for (var i = 0; i<downloadList.length; i++)
		if (downloadList[i].isRemoved)
			t++;
	return t;
}

function getPassedNumber() {
	var t = 0;
	for (var i = 0; i<downloadList.length; i++)
		if (downloadList[i].isPassed && !downloadList[i].isRemoved)
			t++;
	return t;
}

var downloadList = new Array();


// --------* HttpRequestList *--------

function reqQueueElement(req, index) {
	this.req = req;
	this.index = index;
	this.done = false;
}
var httpReqQueue = new Array();

function inProgressElement(index) {
	this.relativeIndex = index;
}

var inProgressList = new Array();


// --------* Notifiche slide *--------

function obsAlert () {
	this.dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
}

obsAlert.prototype.observe = function (aSubject, aTopic, aData){
	switch (aTopic) {
		case "alertfinished":
		  alerting = false;   // se è già partita una slide, non farne partire una seconda
			break;

		case "alertclickcallback":
			if (aData != "errore") {
				try {
					this.dir.initWithPath(aData);
					this.dir.launch();
				 } catch (e) {
					alert("Your system doesn't support this function");
				}
			}
			break;
	}
}

obsAlert.prototype.onAlertFinished = function (aCookie){
	alerting = false;
}

obsAlert.prototype.onAlertClickCallback = function (aCookie){
	if (aCookie != "errore") {
	try {
		this.dir.initWithPath(aCookie);
		this.dir.launch();
    } catch (e){alert("Your system doesn't support this function");}
	}
}

// --------* Controlli di chiusura e avvio nuovi downloads *--------

function check() {
	this.lastCheck = -1;
	this.lastDownloads = -1;
	this.haveToCheck = true;
	this.timer=0;
	this.isClosing = false;
}

check.prototype.checkDownloads = function() {
	try {
		// ogni mezzo secondo aggiorna statusbar e titolo
		
		var data = new Date();
		var sum = 0;
		var diff = 0;
		var speed;
	
		for (var i = 0; i < downloadList.length; i++)
			sum = sum + downloadList[i].partialSize;   	// somma i contributi solo dei download attivi al momento
	
		diff = sum - Stats.downloadedBytes;
		speed = Math.round(diff / 1024 * 2);  				// * 2 in quanto la funzione viene richiamata ogni 500 millisecondi
		Stats.downloadedBytes = sum;
	
		var status = document.getElementById("status");
		var data= new Date();
		status.label = strbundle.getString("cdownloads") + " " + Stats.completedDownloads + " " + strbundle.getString("of")  + " " + Stats.totalDownloads  + " - " +  strbundle.getString("cspeed")  + " " +  speed + " KB/s"
		/*+ " passed=" + getPassedNumber() + " inprogress=" + Stats.inProgress + " " + data.getSeconds();*/
		
		if (inProgressList.length == 1 && downloadList[inProgressList[0].relativeIndex].totalSize > 0) {
			var num = inProgressList[0].relativeIndex;
			document.title = Math.round(downloadList[num].partialSize / downloadList[num].totalSize * 100) + "% - " + Stats.completedDownloads + "/" + Stats.totalDownloads + " - " + speed + " KB/s - DownThemAll! - " + strbundle.getString("dip");
		} else if (inProgressList.length >= 0 )
			document.title = Stats.completedDownloads + "/" + Stats.totalDownloads + " - " + speed + " KB/s - DownThemAll! - " + strbundle.getString("dip");
			
		Prefs.refresh();
		
		// se l'ultima volta non c'è stato nulla da far partire ed il numero totale di download è uguale a prima,
		// non sprecare memoria ciclandoti tutti i download alla ricerca di uno nuovo che non ci sarà
		// [la gestione dei file pausati è in pauseResumeReq()]
		
		// se però il numero di download è cambiato, controlla.
		if ((!this.haveToCheck) && (this.lastDownloads != downloadList.length))
			this.haveToCheck = true;
		
		while ((this.haveToCheck) && (Stats.inProgress < Prefs.maxInProgress) && !Check.isClosing) {
			if (getFirstFreeFile() >= 0) {
				this.lastDownloads = downloadList.length;
					Stats.inProgress++;
					mydump("checkDownloads(): Stats.inProgress = " + Stats.inProgress);
				} else {
					this.haveToCheck = false; // se non c'è nulla da far partire
					break;
				}
		}
	
		this.checkClose();
		
		for (i = 0; i < inProgressList.length; i++) {
		
			var index = inProgressList[i].relativeIndex;
			
			if (downloadList[index].partialSize != 0 && downloadList[index].totalSize != 0) {
				var remainingSeconds = Math.ceil((downloadList[index].totalSize - downloadList[index].partialSize) / (downloadList[index].partialSize / ((data.getTime() - downloadList[index].timeStart)/ 1000)));
				var min = Math.floor(remainingSeconds / 60);
				if (min <= 9)
					min = "0" + min;
				var sec = remainingSeconds - min * 60;
				if (sec <= 9)
					sec = "0" + sec;
				// aggiorna il tempo rimanente
				if (!downloadList[index].isPaused && !downloadList[index].isCanceled && !downloadList[index].isCompleted) {
					document.getElementById(downloadList[index].relativeListboxID).childNodes[0].childNodes[4].attributes.label.value = min + ":" + sec;
				}
			}
			
			// controlla il timeout
			if ((isOpenedMessagebox == 0) && (data.getTime() - downloadList[index].timeLastProgress) >= getPreference("extensions.dta.context.timeout", 60, true) * 1000) {
				
				downloadList[index].setPaused();
				downloadList[index].isPaused = true;
				popup();
				mydump("checkDownloads(): " + index + " in timeout");
				
				document.getElementById(downloadList[index].relativeListboxID).childNodes[0].childNodes[4].attributes.label.value = strbundle.getString("timeout");
				document.getElementById(downloadList[index].relativeListboxID).childNodes[0].childNodes[2].attributes.properties.value = "paused";
				getFirstFreeFile();
			}
			
		}
	
		this.timer = setTimeout("Check.checkDownloads();", 500);
	} catch(e) {
		mydump("checkDownloads(): " + e);
	}
}

check.prototype.checkClose = function() {

	// controlla se la coda è completa (non vuota) ed è diversa dall'ultima, non ci sono decompressioni in corso 
	if ((getPassedNumber() == Stats.totalDownloads)&&(Stats.totalDownloads!=0)&&(this.lastCheck != Stats.downloadedBytes)&&(Stats.zippedFiles==0)) {
	mydump("checkClose(): Tutti i downloads passati correttamente");
	
	try{
		this.lastCheck = Stats.downloadedBytes;
		
		httpReqQueue = new Array();
		
		document.title = Stats.completedDownloads + "/" + Stats.totalDownloads + " - DownThemAll! - " + strbundle.getString("dcom");
		Prefs.refresh();
		
		// se la finestra non è in focus avvisiamo con sidebox e altro
		if (!winFocus) {
			var stringa;
			if (Stats.completedDownloads > 0)
				stringa = strbundle.getString("suc");
			
			if (Prefs.alert == 1 && !alerting) {
				alerting = true;
				alert = Components.classes['@mozilla.org/alerts-service;1'].getService(Components.interfaces.nsIAlertsService);
				if (Stats.completedDownloads > 0)
					alert.showAlertNotification("chrome://dta/content/immagini/alert.png", strbundle.getString("dcom"), stringa, true, downloadList[0].dirSave, new obsAlert());
			} else if (Prefs.alert == 0) {
				if (Stats.completedDownloads > 0)
					if (confirm(stringa + "\n "+ strbundle.getString("folder")) == 1) {
						var dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
						try {
								dir.initWithPath(downloadList[0].dirSave);
								dir.launch();
						} catch (e){strbundle.getString("noFolder");}
					}
			}
		}
		
		
		// se l'utente ha schiacciato la x o se non è in focus e dalla preferenze vuole la chiusura al completamento
		if (getPreference("extensions.dta.context.closedta", false) || Check.isClosing) {
			mydump("checkClose(): Chiudo la finestra/tab");
			clearTimeout(this.timer);
			if (!dTaOpener)
				self.close();
			else
				// nel caso dta sia su tab
				try {
					dTaOpener.removeTab(dTaTab);
				} catch(e) {
					mydump("checkClose(): " + e);
				}
		}
		
		saveSession();

		try {
			var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
			observerService.removeObserver(observerHttp, "http-on-modify-request");
			observerService.removeObserver(observerHttp, "http-on-examine-response");
		}catch(e){}
		
    }catch(e){"checkClose(): " + mydump(e);}
 }
}

var Check = new check();


// --------* Progress Listener per il singolo download *--------

function PersistProgressListener(chunkIndex, index) {

	this.index = index;
	this.chunkIndex = chunkIndex;
	this.cantCount = 0;
}

PersistProgressListener.prototype = {
 QueryInterface : function(aIID) {
	if(aIID.equals(Components.interfaces.nsIWebProgressListener))
	 return this;
	 throw Components.results.NS_OK;
 },

init : function() {var flag=0; var identity=0;},
destroy : function() {},
onStateChange:( function (aWebProgress, aRequest, aStateFlags, aStatus) {
try {
	if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_STOP) {
	
	// aggiorna la dimensione prendendola dal file salvato (utile solo per i file dei quali non si conosce la dimensione)
	downloadList[this.index].chunks[this.chunkIndex].chunkSize = getChunkSize(this.index, this.chunkIndex);
	// aggiorna anche le dimensioni del file padre
	downloadList[this.index].setPartialSize();
	
	// se è un chunk con dimensione zero lo cancelliamo in quanto inutile aggiornando i puntatori
	if (downloadList[this.index].chunks[this.chunkIndex].chunkSize == 0) {
		if (downloadList[this.index].chunks[this.chunkIndex].fileManager.exists())
			downloadList[this.index].chunks[this.chunkIndex].fileManager.remove(false);
		if (downloadList[this.index].chunks[this.chunkIndex].previous != -1)
			downloadList[this.index].chunks[downloadList[this.index].chunks[this.chunkIndex].previous].next = downloadList[this.index].chunks[this.chunkIndex].next;
		if (downloadList[this.index].chunks[this.chunkIndex].next != -1)
			downloadList[this.index].chunks[downloadList[this.index].chunks[this.chunkIndex].next].previous = downloadList[this.index].chunks[this.chunkIndex].previous;
	}
	
	downloadList[this.index].chunks[this.chunkIndex].isRunning = false;
	downloadList[this.index].chunks[this.chunkIndex].isComplete = true;
	
	// controlla che il cambiamento del singolo chunk influenzi anche le proprietà del file intero
	downloadList[this.index].setIsRunning();
	downloadList[this.index].setIsComplete();
	
	// !! questo deve andare dopo setIsComplete() !!
	// !! si modifica la proprietà di range del chunk end accordandosi con la reale quantità scaricata
	downloadList[this.index].chunks[this.chunkIndex].end = downloadList[this.index].chunks[this.chunkIndex].start + downloadList[this.index].chunks[this.chunkIndex].chunkSize - 1; // si parte da zero	
	
	if (!downloadList[this.index].isRemoved)
		document.getElementById(downloadList[this.index].relativeListboxID).childNodes[0].childNodes[5].attributes.label.value = (--downloadList[this.index].numChunks) + "/" + downloadList[this.index].maxChunks;
	
		mydump("onStateChange(): finito chunk " + downloadList[this.index].chunks[this.chunkIndex].start + "-" + downloadList[this.index].chunks[this.chunkIndex].end + " di " + downloadList[this.index].fileName + ". Dimensioni parziali file: " + downloadList[this.index].partialSize + "/" + downloadList[this.index].totalSize 
		+ "byte (completato=" + downloadList[this.index].isCompleted + ")");
	
	// se il download è completo...
	if (downloadList[this.index].isCompleted && !downloadList[this.index].isRemoved) {
	
		if (downloadList[this.index].compression)
			Stats.zippedFiles++;
		
		mydump("completo");
		// faccio partire la ricostruzione del file (gzip si rileva da qui)
		join(this.index); 
		
		// aggiorna a 100% il treeitem
		var elem = document.getElementById(downloadList[this.index].relativeListboxID).childNodes[0];
		downloadList[this.index].totalSize = getFileSize(this.index);
		downloadList[this.index].partialSize = downloadList[this.index].totalSize;
		elem.childNodes[1].attributes.label.value = "100%";
		elem.childNodes[4].attributes.label.value = strbundle.getString("complete");
		elem.childNodes[2].attributes.value.value = 100;
		elem.childNodes[2].attributes.properties.value = "completed";
		elem.childNodes[3].attributes.label.value = createDimensionString(downloadList[this.index].totalSize, downloadList[this.index].totalSize);

			// se non è stato cancellato e se è compresso, uzippalo
		if (downloadList[this.index].compression) {
			if (!downloadList[this.index].isCanceled) {
				try {
					unzip(downloadList[this.index].fileManager, downloadList[this.index].dirSave + downloadList[this.index].destinationName);
				} catch(e){
					mydump("onStateChange(): " + e);
				}
			} else 
				Stats.zippedFiles--;
		}
		
		// aggiorno le statistiche
		downloadList[this.index].isCompleted = true;
		downloadList[this.index].isPassed = true;
		Stats.completedDownloads++;
		Check.checkClose();
		
	} else if (!downloadList[this.index].isPaused && !downloadList[this.index].isCanceled && downloadList[this.index].isResumable) {
		
		// se non è in pausa ma non è completato vuol dire che è semplicemente terminato un chunk
		var maxnumChunk = Math.round(downloadList[this.index].totalSize / (200 * 1024));
		if (maxnumChunk > downloadList[this.index].maxChunks)
			maxnumChunk =  downloadList[this.index].maxChunks;
		
		// se il numero di chunk in corso diventa meno della meta di quelli possibili blocca tutti i chunk correnti...
		if (2 * downloadList[this.index].numChunks < maxnumChunk)
			for (var i = 0; i<downloadList[this.index].chunks.length; i++)
				if (downloadList[this.index].chunks[i].isRunning) {
					downloadList[this.index].chunks[i].progressPersist.cancelSave();
			}
		
		if (!downloadList[this.index].isRunning) {
		  // ..e quando siamo sicuri che li abbiamo bloccati tutti quanti
			//.. allora trova i nuovi spazietti vuoti rimasti e suddividili nuovamente come dio comanda
			resumeThis(this.index);
			downloadList[this.index].isRunning = true;
		}
		
	} else if (!downloadList[this.index].isRunning && downloadList[this.index].isPaused && Check.isClosing){
		// se stiamo chiudendo tramite cancelall, quando tutti i chunk vengono terminati possiamo incrementare 
		// il numero dei down passati per chiudere la finestra automaticamente
		downloadList[this.index].isPassed = true;
		Check.checkClose();
		
	} else if (downloadList[this.index].isCanceled) {
		mydump("onStateChange(): cancello il rimanente, running=" + downloadList[this.index].isRunning);
		
		if (downloadList[this.index].chunks[this.chunkIndex].fileManager.exists())
			downloadList[this.index].chunks[this.chunkIndex].fileManager.remove(false);
		
		if (!downloadList[this.index].isRunning) {
			downloadList[this.index].isPassed = true;
			downloadList[this.index].chunks = new Array();
		}
	}
	
	// se il file (e tutti i suoi chunk quindi) non sono in progresso, togliamo il file dall'inProgress list
	if (!downloadList[this.index].isRunning) {
		Stats.inProgress--;
		mydump("onStateChange(): Stats.inProgress = " + this.index);
		// lo tolgo dall'array inprogressList
		for (var i = 0; i<inProgressList.length; i++)
			if (this.index == inProgressList[i].relativeIndex) {
				inProgressList.splice(i,1);
				break;
			}
	}

	popup(); //aggiorno la toolbar
}
} catch(e) {mydump("onStateChange(): " + e + " " + this.index);}
}),

onProgressChange:(

function (aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {
  
  var elem = document.getElementById(downloadList[this.index].relativeListboxID).childNodes[0];

	// se è in pausa, smettila di scaricare
	if (downloadList[this.index].isPaused) {
		downloadList[this.index].chunks[this.chunkIndex].progressPersist.cancelSave();
	} else if (downloadList[this.index].isCanceled) {
	// se è stato cancellato, smettila di scaricare e cancella il file
		downloadList[this.index].chunks[this.chunkIndex].progressPersist.cancelSave();
		downloadList[this.index].chunks[this.chunkIndex].fileManager.remove(false);
	}	else {
	 
		var data = new Date();
		// se è un nuovo download
		if (this.flag != 1) {
			this.flag = 1;
			mydump("onProgressChange(): partito il chunk " + downloadList[this.index].chunks[this.chunkIndex].start + "-" + + downloadList[this.index].chunks[this.chunkIndex].end + " per " + downloadList[this.index].fileName + " (totale chunks = " + downloadList[this.index].chunks.length + ")");
			// inizializzo la row del tree
			if (!downloadList[this.index].isResumable && aMaxTotalProgress>0)
				downloadList[this.index].totalSize = aMaxTotalProgress;
			elem.childNodes[2].attributes.properties.value = "inprogress";
			
			var chan = aRequest.QueryInterface(Components.interfaces.nsIHttpChannel);
			if (chan.responseStatus >= 400) {
				if (Prefs.alert == 1 && !alerting) {
						alerting = true;
						Components.classes['@mozilla.org/alerts-service;1'].getService(Components.interfaces.nsIAlertsService).showAlertNotification("chrome://dta/content/immagini/alert.png", "Download ", downloadList[this.index].fileName + " failed. Server returned a " + chan.responseStatus + " error: " + chan.responseStatusText, false, "errore", new obsAlert());
					} else if (Prefs.alert == 0)
						alert("Download of " + downloadList[this.index].fileName + " failed. Server returned a " + chan.responseStatus + " error: " + chan.responseStatusText);
					
					cancelThis(this.index, chan.responseStatus + " " + strbundle.getString("error"));
					return;
			}
			
			// leggiamo l'header solo del primo chunk
			if (this.chunkIndex == 0) {
				// leggo gli headers del file
				
				try	{
					if (chan) {
						try	{
							// GET request per il gzip encoding
							downloadList[this.index].compression = (chan.getResponseHeader('Content-Encoding') == 'gzip');
						} catch (e) {}
						try	{
							// GET request per il content-type
							downloadList[this.index].contentType = chan.getResponseHeader("Content-Type");
						} catch (e) {}
						try	{
							// GET request per il content-disposition
							downloadList[this.index].destinationName = chan.getResponseHeader("Content-Disposition").replace(/(.)*filename=["']{0,1}/, "").replace(/["']{0,1}(.)*/, "");
						} catch (e) {
							if (aRequest.URI.spec != downloadList[this.index].url) {
								var url = aRequest.URI.spec;
								var filename = url.substring(url.lastIndexOf("/") + 1, url.length);
								if (filename.indexOf("?") > 0) 
									filename = filename.substring(0, filename.indexOf("?"));
									
								downloadList[this.index].destinationName = filename;
							}	
						}
					}
				} catch (e) {}
				
				var separator = findSeparator();
				// aggiungiame le opzioni di renaming al nomefile, normalizzando
				if (!downloadList[this.index].alreadyMaskedName) {
					downloadList[this.index].destinationName = toggleInvalidChar(makeReplacement(getPreference("extensions.dta.rename.files", "*name*.*ext*"), downloadList[this.index])).replace(/\//g, "");;
					downloadList[this.index].alreadyMaskedName = true;
				}
				
				// controllo la presenza di un file con lo stesso nome e nel caso chiedo cosa fare
				downloadList[this.index].destinationName = renameFile(downloadList[this.index].dirSave, downloadList[this.index].destinationName, this.index);
				
				// se l'utente ha richiesto l'annullamento del download lo cancelliamo
				if (downloadList[this.index].destinationName == -1) {
					cancelThis(this.index, "Skipped");
					return;
				}
				
				const FileFactory = new Components.Constructor("@mozilla.org/file/local;1", "nsILocalFile", "initWithPath");
				downloadList[this.index].fileManager = new FileFactory(downloadList[this.index].dirSave);
				downloadList[this.index].fileManager.append(downloadList[this.index].destinationName); 
			}
		}
		
		if (this.cantCount != 1) {
			if (aMaxTotalProgress == -1) {
				this.cantCount = 1;
				elem.childNodes[4].attributes.label.value = "00:00";
			} else {
				downloadList[this.index].chunks[this.chunkIndex].chunkSize = aCurTotalProgress;
				downloadList[this.index].setPartialSize();
				downloadList[this.index].timeLastProgress = data.getTime();
				var elem = document.getElementById(downloadList[this.index].relativeListboxID).childNodes[0];
				
				if (downloadList[this.index].totalSize != 0) {
					elem.childNodes[2].attributes.value.value = Math.round(downloadList[this.index].partialSize / downloadList[this.index].totalSize * 100);
					elem.childNodes[1].attributes.label.value = Math.round(downloadList[this.index].partialSize / downloadList[this.index].totalSize * 100) + "%";
					elem.childNodes[3].attributes.label.value = createDimensionString(downloadList[this.index].partialSize, downloadList[this.index].totalSize);
				} else {
					elem.childNodes[2].attributes.value.value = 0;
					elem.childNodes[1].attributes.label.value = "";
					elem.childNodes[3].attributes.label.value = createDimensionString(downloadList[this.index].partialSize, downloadList[this.index].totalSize);
				}
			}
		}
	}
}),

onLocationChange: (function (aWebProgress, aRequest, aLocation) {}),
onStatusChange:(function (aWebProgress, aRequest, aStatus, aMessage) {}),
onSecurityChange:(function (aWebProgress, aRequest, aState) {})
};


// --------* Gzip converter *--------

function dataListener(fileUscita, dest)
	{this.outf = fileUscita; this.inf=dest;}

dataListener.prototype.QueryInterface = function(iid) {
	if(iid.equals(Components.interfaces.nsISupports) || iid.equals(Components.interfaces.nsIStreamListener) || iid.equals(Components.interfaces.nsIRequestObserver)) return this;
 throw Components.results.NS_ERROR_NO_INTERFACE;
}

dataListener.prototype.onStartRequest = function(request, context){mydump("parto con la conversione");}

//--> close output file, remove compressed file and, if downloads and decompressions are complete, close dTa
dataListener.prototype.onStopRequest= function(request, context, status){
	mydump("mantengo " + this.outf.path);
	this.outf.close();
	mydump("sto per rimuovere " + this.inf.path);
	this.inf.remove(false);
	Stats.zippedFiles--;
	mydump("conclusa la conversione");
	Check.checkClose();
}

//--> read datas from a scriptable stream which is connected with the output of the converter
dataListener.prototype.onDataAvailable= function(request, context, inputStream, offset, count) {
		try {
		var si = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance();
			si =
			si.QueryInterface(Components.interfaces.nsIScriptableInputStream);
			si.init(inputStream);
	this.outf.write(si.read(count),count);
		} catch(e) {mydump("onDataAvailable(): " + e);}
}



// --------* Inizio funzioni *--------
	
//--> attivata all'onload

function loadDown() {

	strbundle = document.getElementById("strings");
	Prefs.refresh();
	observerHttp = new HeaderInfoLive();
	
	var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
	observerService.addObserver(observerHttp, "http-on-examine-response", false);
	
	loadSession();
	document.getElementById("status").label = strbundle.getString("cdownloads") + Stats.completedDownloads + strbundle.getString("of") + " " + Stats.totalDownloads;
	document.title = Stats.completedDownloads + "/" + Stats.totalDownloads + " - DownThemAll!";
	
	document.getElementById("listDownload0").view.selection.currentIndex = document.getElementById("listDownload0").view.rowCount - 1;
	
	if ("arguments" in window) {
		startnewDownloads(window.arguments[0], window.arguments[1]);
	}
	
	try {
		clearTimeout(Check.timer);
		Check.checkDownloads();
	} catch (e) {
		mydump("loadDown(): " + e);
	}
}

function cancelAll(pressedESC) {
	
	if (getPassedNumber() == Stats.totalDownloads && Stats.zippedFiles == 0) {
		mydump("cancelAll(): chiusura accordata");
		saveSession();
		clearTimeout(Check.timer);
		saveLog();
		if (pressedESC)
			self.close();
		else
			return true;
	} 
	
	// dobbiamo abortire in fretta ogni operazione non ancora terminata
	Check.isClosing = true;
	
	for (var i=0; i<downloadList.length; i++)
		// se non li abbiamo ancora gestiti in chiusura e non si tratta di file che abbiamo rimosso dalla lista
		if (!downloadList[i].isPassed && !downloadList[i].isRemoved) {
			if (downloadList[i].isCanceled || downloadList[i].isCompleted || downloadList[i].isPaused) {
				// su questi non si deve fare nulla
				downloadList[i].isPassed = true;
			} else if (downloadList[i].isStarted) {
				if (!downloadList[i].isRunning)
					downloadList[i].isPassed = true;
				downloadList[i].setPaused();
				downloadList[i].isPaused = true;
			} else {
				if (Prefs.onClosingSaveAborted) {
					downloadList[i].isPaused = true;
					downloadList[i].isPassed = true;
				} else
					removeFromList(i);
			}
		}
		
	if (getPassedNumber() == Stats.totalDownloads && Stats.zippedFiles == 0) {
		mydump("cancelAll(): chiusura accordata");
		saveSession();
		saveLog();
		clearTimeout(Check.timer);
		return true;
	} else
		mydump("cancelAll(): attendo il completamento delle operazioni per chiudere");
	
	return false;
}

//--> richiamata sia da loadDown che da dta.js nel caso di globalqueue
function startnewDownloads(ndown, download) {

	var separator = findSeparator();
	
	// copia l'array passatogli in quello generale
	for (var i=0; i<ndown; i++) {
		var flag=0;
	
		// controlla che l'url non sia già presente in lista
		for (var y = 0; y < downloadList.length; y++) {
			
			// uniformità slash
			if (download[i].dirSave.substr(download[i].dirSave.length - 1, 1) != separator) 
				download[i].dirSave = download[i].dirSave + separator;
			
			if (downloadList[y].url == download[i].url && downloadList[y].dirSave == download[i].dirSave)
				if (!downloadList[y].isRemoved && (downloadList[y].isCanceled || downloadList[y].isCompleted)) {
					removeFromList(y);
					mydump("startnewDownloads(): rimuovo " + downloadList[y].url);
				} else if (downloadList[y].isPaused) {
					downloadList[y].isPaused = false;
					document.getElementById(downloadList[y].relativeListboxID).childNodes[0].childNodes[4].attributes.label.value = strbundle.getString("inqueue");
					flag=1;
				} else if (downloadList[y].isRemoved)
					flag=0;
				else 
				   // in progress
					flag=1;
		}
		
		// se si deve effettivamente scaricare
		if (flag != 1) {
			var indexList = downloadList.length - getRemovedNumber();
			var index = downloadList.length;
			downloadList[index] = new downloadElement(download[i].url, download[i].fileName, download[i].dirSave, download[i].numIstance, indexList, download[i].description);
			downloadList[index].refPage = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
			downloadList[index].refPage.spec = download[i].refPage;
			mydump(download[i].refPage);
			// aggiunge i relativi elementi in listbox
			populateListbox(index);
			downloadList[index].relativeListboxID = "down" + index;
			mydump(download[i].url + ": relativeListboxID = " + index);
			Stats.totalDownloads++;
		}
	}
	
	Check.haveToCheck = true;
	
	try {
		clearTimeout(Check.timer);
		Check.checkDownloads();
	} catch (e) 
	{mydump("startnewDownloads() + " + e);}

}

function passOpener(opener, tab) {

	dTaTab = tab;
	dTaOpener = opener;
}

//--> aggiunge alla listbox gli elementi in array
function populateListbox(num) {

	var lista = document.getElementById("downfigli");
	
	var itemNode = document.createElement("treeitem");
	itemNode.setAttribute("value", downloadList[num].url);
	itemNode.setAttribute("id", "down" + num);
	
	var treeRow = document.createElement("treerow");
	
	var nomefile = document.createElement("treecell");
	
	if (Prefs.reduce)
		nomefile.setAttribute("label", " " + downloadList[num].fileName);
	else
		nomefile.setAttribute("label", " " + downloadList[num].url);
	
	var nome = downloadList[num].fileName;
	if (nome.match(/(\.(z(ip|[0-9]{2})|r(ar|[0-9]{2})|jar|bz2|gz|tar|rpm))$/i))
		nomefile.setAttribute("src", "chrome://dta/content/immagini/zip.png");
	else if (nome.match(/(\.(mpeg|rm|mpe|avi|mpg|mp4|mov|asf|qt|wmv|ram))$/i))
		nomefile.setAttribute("src", "chrome://dta/content/immagini/mpg.png");
	else if (nome.match(/(\.(jpeg|jpg|gif|png|jpe|tif|tiff|bmp|ico))$/i))
		nomefile.setAttribute("src", "chrome://dta/content/immagini/jpg.png");
	else if (nome.match(/(\.(wav|mp3|mid|m4a))$/i))
		nomefile.setAttribute("src", "chrome://dta/content/immagini/mp3.png");
	else if (nome.match(/(\.(txt|rtf|png|xls|doc|pdf))$/i))
		nomefile.setAttribute("src", "chrome://dta/content/immagini/doc.png");
	else if (nome.match(/(\.(html|htm|css|rss|xml|js))$/i))
		nomefile.setAttribute("src", "chrome://dta/content/immagini/htm.png");
	else
		nomefile.setAttribute("src", "chrome://dta/content/immagini/other.png");

	nomefile.setAttribute("ref", "task");

	var per = document.createElement("treecell");

	var per1 = document.createElement("treecell");
	per1.setAttribute("mode", "normal");
	per1.setAttribute("ref", "pct");

	var dim = document.createElement("treecell");
	dim.setAttribute("ref", "dim");
	
	var time = document.createElement("treecell");
	time.setAttribute("ref", "time");
	
	var path = document.createElement("treecell");
	path.setAttribute("label", downloadList[num].dirSave);
	path.setAttribute("ref", "path");
	
	var parts = document.createElement("treecell");
	parts.setAttribute("label", "0/" + downloadList[num].maxChunks);
	parts.setAttribute("ref", "parts");

	if (downloadList[num].isCompleted) {
		time.setAttribute("label", strbundle.getString("complete"));
		per1.setAttribute("properties", "completed");
	} else if (downloadList[num].isPaused && !downloadList[num].isCanceled) {
		time.setAttribute("label", strbundle.getString("paused"));
		per1.setAttribute("properties", "paused");
	} else if (downloadList[num].isCanceled) {
		time.setAttribute("label", strbundle.getString("canceled"));
		per1.setAttribute("properties", "canceled");
	} else {
		time.setAttribute("label", strbundle.getString("inqueue"));
		per1.setAttribute("properties", "queued");
	}
	
	if (downloadList[num].partialSize != 0 && downloadList[num].totalSize != 0) {
		
		dim.setAttribute("label", createDimensionString(downloadList[num].partialSize, downloadList[num].totalSize));
		per1.setAttribute("value", Math.round(downloadList[num].partialSize / downloadList[num].totalSize * 100));
		per.setAttribute("label", Math.round(downloadList[num].partialSize / downloadList[num].totalSize * 100) + "%");
	} else {
		dim.setAttribute("label", "N/A");
		per1.setAttribute("value", 0);
		per.setAttribute("label", "0%");
	}
	
	treeRow.appendChild(nomefile);
	treeRow.appendChild(per);
	treeRow.appendChild(per1);
	treeRow.appendChild(dim);
	treeRow.appendChild(time);
	treeRow.appendChild(parts);
	treeRow.appendChild(path);
	
	itemNode.appendChild(treeRow);
	lista.appendChild(itemNode);
	lista.addEventListener("dblclick", openFile, true);
}

function createDimensionString(partial, total) {
	if (total/Math.pow(1024,3) > 1)
		return (partial / Math.pow(1024,3)).toFixed(2) + " GB/" + (total / Math.pow(1024,3)).toFixed(2) + " GB";
	else if (total/Math.pow(1024,2) > 1)
		return (partial / Math.pow(1024,2)).toFixed(2) + " MB/" + (total / Math.pow(1024,2)).toFixed(2) + " MB";
	else if (total/1024 > 1)
		return Math.ceil(partial / 1024) + " KB/" + Math.ceil(total / 1024) + " KB";
	else
		return partial + " B/" + total + " B";
}


//--> si occupa di ricercare il primo file da far partire
function getFirstFreeFile() {

	var tree = document.getElementById("listDownload0");
	try {
		for (var x = 0; x<tree.view.rowCount; x++) {
			var i = findElementById(tree.view.getItemAtIndex(x).id);
			// se non è cancellato, non è in pausa, non è già completato ed è in coda che aspetta
			if ((!downloadList[i].isCanceled) && (!downloadList[i].isPaused) && (!downloadList[i].isCompleted) && (!downloadList[i].isRunning)) {
				// è già partito o è un nuovo download?
				if (!downloadList[i].isStarted) {
					downloadList[i].isStarted = true;
					mydump("inizio file " + downloadList[i].fileName);
					document.getElementById(downloadList[i].relativeListboxID).childNodes[0].childNodes[4].attributes.label.value = strbundle.getString("starting");
					getHeader(i);
				} else 
					// se hanno size 0 vuol dire che son quelli che abbiam fatto partire prima e hanno
					// ritardo, non sono da far ripartire. si aspetta che partino o che diano timeout
					if (downloadList[i].partialSize != 0 || downloadList[i].chunks.length > 0) {
						mydump("resumo file " + downloadList[i].fileName);
						var lastSon = i;
						resumeThis(i);
					} else 
						continue;
				
				var data = new Date();
				downloadList[i].timeLastProgress = data.getTime();
				downloadList[i].isRunning = true;
				
				var found = false;
				for (var c = 0; c < inProgressList.length; c++)
					if (inProgressList[c].relativeIndex == i) {
						found = true;
						break;
					}
				if (!found) {
					inProgressList.push(new inProgressElement(i));
					downloadList[i].timeStart = data.getTime();
				}
				return i;
			}
		}
	} catch(e) {
		mydump("GetFirstFreeFile(): " + e);
	}
	return -1;
}

//--> aggiunge elemento alla pila delle httprequests
function getHeader(i) {

	try {

		//mydump("prima di aggiungerlo: " + httpReqQueue.length);
		var xmlHttpReq = new XMLHttpRequest()
		httpReqQueue.push(new reqQueueElement(xmlHttpReq, i));

		//mydump("aggiungo " + downloadList[i].fileName + " alla coda: " + httpReqQueue.length);
		xmlHttpReq.onreadystatechange = checkHeader;
		xmlHttpReq.open('HEAD', downloadList[i].url, true);

		//if queue was previously empty, there is no request being sent
		//so send this request immediately
		if (httpReqQueue.length == 1) {
			xmlHttpReq.send(null);
			//mydump("avvio il primo della coda");
		}

	} catch (e) {
		mydump("getHeader(): " + e);
	}
}

//--> richiamata dall'httprequest quando è pronta
function checkHeader() {
try {
	if ((httpReqQueue[0].req.readyState == 4) && (!httpReqQueue[0].done)) {
	
		try {
		
			httpReqQueue[0].done = true;
	
			// BUG INCAPIBILE. il primo all'avvio di una global queue da errore qui.
			try {
				var status1 = httpReqQueue[0].req.status;
			} catch(e) {
				var status1 = 0;
			}
			
			if (status1 >= 400) {
				
				mydump("checkHeader(): " + downloadList[httpReqQueue[0].index].fileName + ": e' un errore " + status1);
				
				Stats.inProgress--;
				mydump("checkHeader(): Stats.inProgress = " + Stats.inProgress);
				if (Prefs.alert == 1 && !alerting) {
					alerting = true;
					Components.classes['@mozilla.org/alerts-service;1'].getService(Components.interfaces.nsIAlertsService).showAlertNotification("chrome://dta/content/immagini/alert.png", "Download ", downloadList[httpReqQueue[0].index].fileName + " failed. Server returned a " + httpReqQueue[0].req.status + " error: " + httpReqQueue[0].req.statusText, false, "errore", new obsAlert());
				} else if (Prefs.alert == 0)
					alert("Download of " + downloadList[httpReqQueue[0].index].fileName + " failed. Server returned a " + httpReqQueue[0].req.status + " error: " + httpReqQueue[0].req.statusText);
				
				cancelThis(httpReqQueue[0].index, status1 + " " + strbundle.getString("error"));
				
				if (getFirstFreeFile() >= 0)
					Stats.inProgress++;

			} else {
				
				mydump("checkHeader(): " + downloadList[httpReqQueue[0].index].fileName + ": non e' un errore 400");
				
				try {
					if (httpReqQueue[0].req.getResponseHeader("Accept-Ranges")=="bytes") 
						downloadList[httpReqQueue[0].index].isResumable = true;
				} catch (e) {}
				
				try {
					if (status1 == 206) {
						var range = oHttp.getResponseHeader("Content-Range");
						var dim = range.substring(range.lastIndexOf("/") + 1, range.length);
						downloadList[i].totalSize = (dim!="*")?dim:0;
						mydump("PartialContent");
					} else {
						var dim = httpReqQueue[0].req.getResponseHeader("Content-Length");
						downloadList[httpReqQueue[0].index].totalSize = (dim>0)?dim:0;
					}
				} catch (e) {}
				
				mydump("getHeader(): faccio partire il file");
				downloadFile(httpReqQueue[0].index);
			}
			
		} catch (e) {
			mydump("errore globale in controlla : " + e);
		}
		
		// faccio crepare quello appena usato
		httpReqQueue[0].req.abort();
		httpReqQueue[0].req = null;
		httpReqQueue[0] = null;
		httpReqQueue.shift();
		
		// send the next request if queue isn't empty
		if (httpReqQueue.length > 0) {
			httpReqQueue[0].req.send(null);
		}
		Check.checkClose();
	}
}catch(e) {mydump("checkHeader(): " + e);}
}

// --------* HTTP Request Observer *-------
// Creato in quanto può essere NETTAMENTE più rapido delle httprequest
// Il programma automaticamente prende il primo arrivato

function HeaderInfoLive() {}

HeaderInfoLive.prototype = {
	
	// This is the observerService's observe listener.
	observe: function(aSubject, aTopic, aData) {
	try {
	 if (aTopic == 'http-on-modify-request') {
		aSubject.QueryInterface(Components.interfaces.nsIHttpChannel);
		this.onModifyRequest(aSubject);
	 } else if (aTopic == 'http-on-examine-response') {
		aSubject.QueryInterface(Components.interfaces.nsIHttpChannel);
		this.onExamineResponse(aSubject);
	 }
	} catch(e) {} 
	},
	
	onExamineResponse : function(oHttp) {
	try {
	 var name = oHttp.URI.asciiSpec;
	 var origname = oHttp.originalURI.asciiSpec;
	 
	 for (var i = 0; i<downloadList.length; i++)
			if (downloadList[i].url == origname && !downloadList[i].isCompleted && !downloadList[i].isRemoved && downloadList[i].numChunks == 0) {
				
				// tolgo la richiesta dall'elenco degli httpReqQueue, la sto gestendo da qui
				if (httpReqQueue.length > 0) {
					httpReqQueue[0].done = true;
					httpReqQueue[0].req.abort();
					httpReqQueue[0].req = null;
					httpReqQueue[0] = null;
					httpReqQueue.shift();
					if (httpReqQueue.length > 0)
						httpReqQueue[0].req.send(null);
				}
					
				if (oHttp.responseStatus < 400) {
					mydump("HeaderInfoLive(): " + downloadList[i].fileName + ": non e' un errore 404");
					
					try {
						if (oHttp.getResponseHeader("Accept-Ranges")=="bytes") 
							downloadList[i].isResumable = true;
					} catch (e) {}
					
					try {
						// if Partial-Content
						if (oHttp.responseStatus == 206) {
							var range = oHttp.getResponseHeader("Content-Range");
							var dim = range.substring(range.lastIndexOf("/") + 1, range.length);
							downloadList[i].totalSize = (dim!="*")?dim:0;
							mydump("PartialContent");
						} else {
							var dim = oHttp.getResponseHeader("Content-Length");
							downloadList[i].totalSize = (dim>0)?dim:0;
						}
						mydump("HeaderInfoLive: filesize=" + downloadList[i].totalSize);
					} catch (e) {}
					
					downloadFile(i);
					
				} else {
					mydump("HeaderInfoLive(): " + downloadList[i].fileName + ": e' un errore " + oHttp.responseStatus);
					
					Stats.inProgress--;
					mydump("HeaderInfoLive(): Stats.inProgress = " + Stats.inProgress);
					
					if (Prefs.alert == 1 && !alerting) {
						alerting = true;
						Components.classes['@mozilla.org/alerts-service;1'].getService(Components.interfaces.nsIAlertsService).showAlertNotification("chrome://dta/content/immagini/alert.png", "Download ", downloadList[i].fileName + " failed. Server returned a " + oHttp.responseStatus + " error: " + oHttp.responseStatusText, false, "errore", new obsAlert());
					} else if (Prefs.alert == 0)
						alert("Download of " + downloadList[httpReqQueue[0].index].fileName + " failed. Server returned a " + httpReqQueue[0].req.status + " error: " + httpReqQueue[0].req.statusText);
					
					cancelThis(httpReqQueue[0].index, status1 + " " + strbundle.getString("error"));
					
					if (getFirstFreeFile() >= 0)
						Stats.inProgress++;
				}
			break;
		}
	} catch(e) {"HeaderInfoLive(): " + mydump(e);} 
	}
}

var observerHttp;


// fa partire lo scaricamento dei chunk, decidendo o meno per il multipart
function downloadFile(index) {
	
	const FileFactory = new Components.Constructor("@mozilla.org/file/local;1", "nsILocalFile", "initWithPath");
try {

	var separator = findSeparator();
	
	// normalizziamo la sottodir che serve subito (togliamo eventuali doppi slash, togliamo slash iniziali e finali)
	if (!downloadList[index].alreadyMaskedDir) {
		var subdir = toggleInvalidChar(makeReplacement(getPreference("extensions.dta.rename.dir", ""), downloadList[index])).replace(/(\\){2,}/g, "\\").replace(/(\/){2,}/g, "/").replace(/\\/g, findSeparator()).replace(/\//g, findSeparator());
		downloadList[index].alreadyMaskedDir = true;
	
		if (subdir.substring(0,1) == separator) 
			subdir = subdir.substring(1, subdir.length);
		if (subdir.substr(subdir.length - 1, 1) == separator) 
			subdir = subdir.substring(0, subdir.length - 1);
		
		if (subdir.length > 0)
			downloadList[index].dirSave = (downloadList[index].dirSave + subdir + separator);
	}
	
	var numChunk = downloadList[index].maxChunks;
	var minSize = 200 * 1024;
	
	if ((downloadList[index].totalSize <= 2 * minSize) || (!downloadList[index].isResumable)) {
	
		// non è possibile eseguire il multipart o il file è troppo piccolo
		mydump("downloadFile(): Singolo di download per " + downloadList[index].fileName + " : " + downloadList[index].totalSize + "bytes, resumable = " + downloadList[index].isResumable );
		
		if (downloadList[index].totalSize > 0)
			downloadChunk(0, downloadList[index].totalSize -1, index, -1);
		else
			downloadChunk(0, "", index, -1);
		
	} else {
		// multipart
		if ((downloadList[index].totalSize / numChunk) < minSize) {
			// serve un numero inferiore a numChunk di chunks
			numChunk = Math.round(downloadList[index].totalSize / minSize);
		}
		
		stChunkSize = Math.round(downloadList[index].totalSize / numChunk);
		
		mydump("downloadFile(): Download in multipart per " + downloadList[index].fileName + " : " + downloadList[index].totalSize + "bytes, resumable = " + downloadList[index].isResumable + ".\n" 
		      + "Suddivido in " + numChunk + " chunks da " + stChunkSize);
		
		for (var i = 0; i<(numChunk-1); i++)
			downloadChunk(stChunkSize * i, (stChunkSize * (i + 1)) - 1, index, i - 1);
		
		downloadChunk(stChunkSize * i, downloadList[index].totalSize - 1, index, i - 1); // l'ultimo va fino alla fine
	}
}catch(e) {
	mydump("downloadFile(): " + e);
}
}

function isInProgress (path, index) {
	for (var x = 0; x < downloadList.length; x++) {
		if ((downloadList[x].dirSave + downloadList[x].destinationName) == path && x != index && !downloadList[x].isCanceled && downloadList[x].isStarted)
			return true;
	}
	return false;
}

function renameFile(destinationDir, destinationName, index) {
try { 
	var newDestinationName = destinationName;
	const FileFactory = new Components.Constructor("@mozilla.org/file/local;1", "nsILocalFile", "initWithPath");
	const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
	
	var i = 0;
	
	// controllo che anche in progress non ci siano due file con uguale destinazione
	while (isInProgress(destinationDir + newDestinationName, index)) {
		newDestinationName = createNumber(++i, destinationName); // ora i due sono diversi
	}
	
	// destinazione reale (realDest)
	var realDest = new FileFactory(destinationDir);
	realDest.append(newDestinationName);

	// decido cosa fare
	if (realDest.exists()) {
		mydump("il file esiste gia");
		Prefs.refresh();
		var scelta;
		if (Prefs.renaming == 3 && Prefs.askEveryTime) {
			var Object1 = new Object();
			Object1.filename = newDestinationName;
			isOpenedMessagebox++;
			window.openDialog("chrome://dta/content/dta/dialog.xul","_blank","chrome, centerscreen, resizable=no, dialog=yes, modal, close=no", Object1);
			isOpenedMessagebox--;
			// non faccio registrare il timeout
			var data = new Date();
			for (var i=0; i<inProgressList.length; i++)
				downloadList[inProgressList[i].relativeIndex].timeLastProgress = data.getTime();
			Prefs.sessionPreference = scelta = Object1.scelta;
			Prefs.askEveryTime = Object1.temp;
		} else {
			if (Prefs.renaming == 3)
				scelta = Prefs.sessionPreference;
			else
				scelta = Prefs.renaming;
		}
		mydump("scelta = "+scelta);
		if (scelta == 0) {
			// rename
			while (realDest.exists()) {
				newDestinationName = createNumber(++i, destinationName); // ora i due sono diversi
				
				// ricreo la dir
				realDest = null;
				realDest = new FileFactory(destinationDir); 
				// rinomino 
				realDest.append(newDestinationName);
			}
			
		} else if (scelta == 1) {
		
			//overwrite
			realDest.remove(false);
		
		} else 
			// skippo
			newDestinationName = -1;
		
	}
	realDest = null;
	return newDestinationName;
}catch(e) {
	mydump("renameFile()" + e);
}
return destinationName;
}


function downloadChunk(start, end, relative, fatherChunk) {

	const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
	const FileFactory = new Components.Constructor("@mozilla.org/file/local;1", "nsILocalFile", "initWithPath");
	
	try {
		chunkIndex = downloadList[relative].chunks.length;
		downloadList[relative].chunks.push(new chunk(start, end, relative));
		downloadList[relative].chunks[chunkIndex].isRunning = true;
		
		if (fatherChunk != -1) {
			downloadList[relative].chunks[chunkIndex].previous = fatherChunk;
			if (downloadList[relative].chunks[fatherChunk].next != -1) {
				downloadList[relative].chunks[chunkIndex].next = downloadList[relative].chunks[fatherChunk].next;
				var nextpadre = downloadList[relative].chunks[fatherChunk].next;
				downloadList[relative].chunks[nextpadre].previous = chunkIndex;
			}
			downloadList[relative].chunks[fatherChunk].next = chunkIndex;
		}
		
		// nome file temporaneo
		var baseChunkName = "dtatempfile" + relative + ".part" + chunkIndex;
		var realDest;
		var xx=-1;
		
		do {
			if (Prefs.saveInTemp) {
				realDest = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("TmpD", Components.interfaces.nsIFile);
				realDest.append("dta");
			} else
				realDest = new FileFactory(downloadList[relative].dirSave);
			
			if (xx != -1)
				downloadList[relative].chunks[chunkIndex].chunkName = createNumber(xx) + "_" + baseChunkName;
			else
				downloadList[relative].chunks[chunkIndex].chunkName = baseChunkName;
			
			realDest.append(downloadList[relative].chunks[chunkIndex].chunkName);
			xx++;
		} while (realDest.exists());
		
		// start the download
		var filetype = new FileFactory(downloadList[relative].dirSave);
		realDest.createUnique(filetype.NORMAL_FILE_TYPE, 0766);
		
		downloadList[relative].chunks[chunkIndex].fileManager = realDest;
		
		var uri = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
		uri.spec = downloadList[relative].url;

		downloadList[relative].chunks[chunkIndex].progressPersist = Components.classes['@mozilla.org/embedding/browser/nsWebBrowserPersist;1'].createInstance(Components.interfaces.nsIWebBrowserPersist);
		
		var flags = nsIWBP.PERSIST_FLAGS_NO_CONVERSION | nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES | nsIWBP.PERSIST_FLAGS_BYPASS_CACHE;
		downloadList[relative].chunks[chunkIndex].progressPersist.persistFlags = flags;
		downloadList[relative].chunks[chunkIndex].progressPersist.progressListener = new PersistProgressListener(chunkIndex, relative);
		downloadList[relative].chunks[chunkIndex].progressPersist.saveURI(uri, null, downloadList[relative].refPage, null, "Range: bytes=" + start + "-" + end + "\r\n", downloadList[relative].chunks[chunkIndex].fileManager);
		mydump("downloadChunk(): creato chunk per " + downloadList[relative].fileName + " - Range = " + start + "-" + end);
		
		mydump("relativeID = " + downloadList[relative].relativeListboxID + " relative = " + relative);
		
		document.getElementById(downloadList[relative].relativeListboxID).childNodes[0].childNodes[5].attributes.label.value = (++downloadList[relative].numChunks) + "/" + downloadList[relative].maxChunks;
		
		saveSession();
		
	} catch (e) {
	
		mydump("downloadChunk():" + e);
		
		cancelThis(relative, strbundle.getString("localerror"));
		Stats.inProgress--;
		
		if (Prefs.alert == 1 && !alerting) {
			alerting = true;
			Components.classes['@mozilla.org/alerts-service;1'].getService(Components.interfaces.nsIAlertsService)
				.showAlertNotification("chrome://dta/content/immagini/alert.png", strbundle.getString("errordownload"), downloadList[relative].fileName + " " + strbundle.getString("failed") + ".", false, "errore", new obsAlert());
		} else
			alert(strbundle.getString("errordownload") + ": " + downloadList[relative].fileName + " " + strbundle.getString("failed") + ": " + e);
	}
	
}


//--> remove from the filename (or directory) invalid characters
function toggleInvalidChar(filename) {
	try{
		filename = filename.replace(/\?/g, "_").replace(/&/g, "_").replace(/=/g, "_").replace(/:/g, "_").replace(/</g, "_").replace(/>/g, "_").replace(/%20/g, " ").replace(/%2520/g, " ").replace(/\*/g, "_").replace(/\|/g, "_").replace(/\\/g, "_").replace(/(\/){2,}/g, "/").replace(/"/g, "");
		return filename;//"
	} catch(e) {
		return "";
	}
}

//--> decompress a file
function unzip(dest, destOrig){

    try {
        var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
        var fileURI = ios.newFileURI(dest);
        var channel = ios.newChannelFromURI(fileURI); // create a channel from the zipped file
        mydump("destOrig: " + destOrig + " sorgente: " + dest.path);
        const FileFactory = new Components.Constructor("@mozilla.org/file/local;1", "nsILocalFile", "initWithPath");
        var nomeFileOut = new FileFactory(destOrig);
        var fileUscita = Components.classes['@mozilla.org/network/file-output-stream;1'].createInstance(Components.interfaces.nsIFileOutputStream);
        nomeFileOut.create(nomeFileOut.NORMAL_FILE_TYPE, 0766);

        fileUscita.init(nomeFileOut, 0x04, 0766, 0); // initialize output file

        var converter = Components.classes['@mozilla.org/streamconv;1?from=gzip&to=uncompressed'].createInstance(Components.interfaces.nsIStreamConverter);
        var list = new dataListener(fileUscita, dest);
        
        if ("AsyncConvertData" in converter) // set up the gzip converter
              converter.AsyncConvertData("gzip", "uncompressed", list, null); 
            else
              converter.asyncConvertData("gzip", "uncompressed", list, null); 
        
            channel.asyncOpen(converter,null); // start the conversion
    }
    catch (e) {mydump("Unzip(): " + e);}
}

//--> unisce i chunk relativi allo stesso download e muovendoli nella directory
function join(index) {
 try {
		
		var destinationName = (downloadList[index].compression)?("[comp]"+downloadList[index].destinationName):downloadList[index].destinationName;
		const FileFactory = new Components.Constructor("@mozilla.org/file/local;1", "nsILocalFile", "initWithPath");
		var nomeFileOut = new FileFactory(downloadList[index].dirSave + destinationName);
      
		if (downloadList[index].chunks.length == 1) {
			
			// se ne abbiamo solo uno non serve il join, si sposta semplicemente rinominando
			var destination = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			destination.initWithPath(downloadList[index].dirSave);
			
			downloadList[index].chunks[0].fileManager.moveTo(destination, destinationName);
			
		} else {

			var fileUscita = Components.classes['@mozilla.org/network/file-output-stream;1'].createInstance(Components.interfaces.nsIFileOutputStream);
			
			nomeFileOut.create(nomeFileOut.NORMAL_FILE_TYPE, 0766);
			fileUscita.init(nomeFileOut, 0x04, 0766, 0); // initialize output file
			var byteOut = Components.classes['@mozilla.org/binaryoutputstream;1'].createInstance(Components.interfaces.nsIBinaryOutputStream);
			byteOut.setOutputStream(fileUscita);
			var i = downloadList[index].firstChunk;
			
			do {
				try {
				streamArray = Components.classes['@mozilla.org/network/file-input-stream;1'].createInstance(Components.interfaces.nsIFileInputStream);
				streamArray.init(downloadList[index].chunks[i].fileManager, 0x04, 0766,0);
				byteStream = Components.classes['@mozilla.org/binaryinputstream;1'].createInstance(Components.interfaces.nsIBinaryInputStream);
				byteStream.setInputStream(streamArray);
				
				var dim = byteStream.available();
				do {
						byteOut.writeBytes(byteStream.readBytes(dim),dim);
						dim = byteStream.available();
						streamArray.close();
						byteStream.close();
				} while (dim!=0);
				downloadList[index].chunks[i].fileManager.remove(false); // rimuove il file temporaneo
				} catch(e) {}
				i = downloadList[index].chunks[i].next;
			} while (i!=-1);
			
			byteOut.close();
			fileUscita.close();
		}
	mydump("join(): Nome fileout = " + nomeFileOut.path);
    downloadList[index].fileManager = nomeFileOut;
     } catch(e) {mydump("join(): " + e + " " + downloadList[index].destinationName + " " + index);}   
}

function makeNumber(number) {
	var stringa;	
	if (number <= 9)
		{ stringa = "00" + number;}
	else if (number <= 99 && number >= 10)
		{ stringa = "0" + number;}
	else
		{stringa = number;}
	return stringa;
}

//--> crea un numero con tot zeri prima, da migliorare
function createNumber(number, destination) {

	var stringa = makeNumber(number);		
	var re = /(\.[^\.]*)$/i;
	var find = re.exec(destination);
	if (find != null)
		destination = destination.replace(/(\.[^\.]*)$/, "_" + stringa + find[0]);
	else
		destination = destination + "_" + stringa;

	return destination;
}

//--> effettua le sostituzioni utilizzando i tag jolly delle preferenze
function makeReplacement (mask, element) {

	var temp;
	var date = new Date();
	var day = ((temp = date.getDate()) < 10) ? '0' + temp : temp;
	var month = ((temp = date.getMonth() + 1) < 10) ? '0' + temp : temp;
	var year = date.getFullYear();
	var hours = ((temp = date.getHours()) < 10) ? '0' + temp : temp;
	var minutes = ((temp = date.getMinutes()) < 10) ? '0' + temp : temp;
	var seconds = ((temp = date.getSeconds()) < 10) ? '0' + temp : temp;

	var baseurl = element.url.replace("http://", "");
	baseurl = baseurl.substring(0, baseurl.indexOf("/"));

	var curl = element.url.replace("http://", "");
	curl = (curl.substring(0, curl.lastIndexOf("/"))).replace(/\//g, "-");

	var sub = element.url.replace("http://", "");
	sub = sub.substring(sub.indexOf("/") + 1, sub.lastIndexOf("/")).replace(/\//g, "-");
	if (sub == "-") 
		sub = "";
 
	var ext = "";
	var fname = "";

	//--> TODO: da migliorare molto
	
	if (element.destinationName.lastIndexOf(".") != -1) {
		ext = element.destinationName.substring(element.destinationName.lastIndexOf(".") + 1, element.destinationName.length);
		fname = element.destinationName.substring(0, element.destinationName.lastIndexOf("."));
	} else {
		if (toggleInvalidChar(element.description) != "") 
			fname = toggleInvalidChar(element.description);
		else
			fname = element.destinationName;
			ext = "";
	}
	
	try {
		if (element.contentType.lastIndexOf("html") != -1) {
			var f = ext.toLowerCase();
			if (f != "html" && f != "htm") {
				ext = "html";
				if (removeSpaces(toggleInvalidChar(element.description)) != "")
					fname = toggleInvalidChar(element.description);
				else
					fname = element.destinationName;
			}
		}
	} catch (e) {}

	removeSpaces(fname);

	var retValue =  mask.replace(/\*name\*/g, fname).replace(/\*ext\*/g, ext).replace(/\*url\*/g, baseurl).
			replace(/\*curl\*/g, curl).replace(/\*num\*/g, makeNumber(element.numIstance)).replace(/\*hh\*/g, hours).
			replace(/\*mm\*/g, minutes).replace(/\*ss\*/g, seconds).replace(/\*d\*/g, day).
			replace(/\*m\*/g, month).replace(/\*y\*/g, year).replace(/\*subdirs\*/g, sub).replace(/\*text\*/g, toggleInvalidChar(element.description));
    return retValue;
}

function removeSpaces(fname) {
 while (fname.substring(0,1) == ' ' || fname.substring(0,1) == '_')
		fname = fname.substring(1,fname.length);

 while (fname.substring(fname.length-1,fname.length) == ' ' || fname.substring(fname.length-1,fname.length) == '_')
		fname = fname.substring(0,fname.length-1);
		
	return fname;
}

//--> determina lo slash del sistema operativo
function findSeparator() {

	const DIR_SERVICE = new Components.Constructor("@mozilla.org/file/directory_service;1","nsIProperties");
	try {
		var path=(new DIR_SERVICE()).get("ProfD", Components.interfaces.nsIFile).path;
	} catch (e) {}

	// determine the file-separator
	if (path.search(/\\/) != -1) return "\\"; else return "/";
}


// ---------* Parte relativa a pause, resume, cancel e context in generale *----------

//--> disabilita le voci nella context non applicabili ai file selezionati
function popup() {

	//disabilito tutto di default
	document.getElementById("pause").setAttribute("disabled", "true");
	document.getElementById("unpause").setAttribute("disabled", "true");
	document.getElementById("cancel").setAttribute("disabled", "true");
	document.getElementById("toolpause").setAttribute("disabled", "true");
	document.getElementById("toolunpause").setAttribute("disabled", "true");
	document.getElementById("toolcancel").setAttribute("disabled", "true");
	document.getElementById("folder").setAttribute("disabled", "true");
	document.getElementById("addchunk").setAttribute("disabled", "true");
	document.getElementById("removechunk").setAttribute("disabled", "true");
	document.getElementById("launch").setAttribute("disabled", "true");

	var tree = document.getElementById("listDownload0");
	var rangeCount = tree.view.selection.getRangeCount();
	var selezione = false;
	
	for(var i=0; i<rangeCount; i++) {
		 var start = {};
		 var end = {};
		 tree.view.selection.getRangeAt(i,start,end);
		 
		 // ciclo gli elementi selezionati
		 for(var c=start.value; c<=end.value; c++) {
				selezione = true;
		 
				var lastSon = findElement(c);
				// se non è cancellato, non è in pausa, non è completato,
				// e se è un file è già iniziato è pausabile
				if (
					(!downloadList[lastSon].isCanceled)&&(!downloadList[lastSon].isPaused)&&(!downloadList[lastSon].isCompleted)
					&& (
						((downloadList[lastSon].partialSize != 0)&&(downloadList[lastSon].isResumable))
						||
						(downloadList[lastSon].partialSize == 0))
				) {
					document.getElementById("pause").setAttribute("disabled", "false");
					document.getElementById("toolpause").setAttribute("disabled", "false");
				}
				
				// se non è cancellato, è in pausa, non è completato,
				// e se è un file è già iniziato è riesumabile
				if (
					(
						(!downloadList[lastSon].isCanceled)&&(downloadList[lastSon].isPaused)&&(!downloadList[lastSon].isCompleted)
						&& (
							((downloadList[lastSon].partialSize != 0)&&(downloadList[lastSon].isResumable))
							||
							(downloadList[lastSon].partialSize == 0)
						)
					) 
					||
					(
						(downloadList[lastSon].isCanceled)&&(!downloadList[lastSon].isRunning)
					)
				) {
					document.getElementById("unpause").setAttribute("disabled", "false");
					document.getElementById("toolunpause").setAttribute("disabled", "false");
				}
				
				if ((!downloadList[lastSon].isCanceled) && (!downloadList[lastSon].isCompleted)) {
					document.getElementById("cancel").setAttribute("disabled", "false");
					document.getElementById("toolcancel").setAttribute("disabled", "false");
				}
				
				if (downloadList[lastSon].isCompleted) {
				  document.getElementById("folder").setAttribute("disabled", "false");
				  document.getElementById("launch").setAttribute("disabled", "false");
				}
				
				if ((!downloadList[lastSon].isCanceled)&&(!downloadList[lastSon].isCompleted)&&(downloadList[lastSon].numChunks > 2)&&(downloadList[lastSon].isResumable))
					document.getElementById("removechunk").setAttribute("disabled", "false");
					
				if ((!downloadList[lastSon].isCanceled)&&(!downloadList[lastSon].isCompleted)&&(downloadList[lastSon].numChunks < 10)&&(downloadList[lastSon].isResumable))
					document.getElementById("addchunk").setAttribute("disabled", "false");
				
		 }
	}
	
	if (selezione) {
		document.getElementById("movetop").setAttribute("disabled", "false");
		document.getElementById("toolmovetop").setAttribute("disabled", "false");
		document.getElementById("movebottom").setAttribute("disabled", "false");
		document.getElementById("toolmovebottom").setAttribute("disabled", "false");
		document.getElementById("moveup").setAttribute("disabled", "false");
		document.getElementById("toolmoveup").setAttribute("disabled", "false");
		document.getElementById("movedown").setAttribute("disabled", "false");
		document.getElementById("toolmovedown").setAttribute("disabled", "false");
		document.getElementById("info").setAttribute("disabled", "false");
		document.getElementById("remove").setAttribute("disabled", "false");
	} else {
		document.getElementById("movetop").setAttribute("disabled", "true");
		document.getElementById("toolmovetop").setAttribute("disabled", "true");
		document.getElementById("movebottom").setAttribute("disabled", "true");
		document.getElementById("toolmovebottom").setAttribute("disabled", "true");
		document.getElementById("moveup").setAttribute("disabled", "true");
		document.getElementById("toolmoveup").setAttribute("disabled", "true");
		document.getElementById("movedown").setAttribute("disabled", "true");
		document.getElementById("toolmovedown").setAttribute("disabled", "true");
		document.getElementById("info").setAttribute("disabled", "true");
		document.getElementById("remove").setAttribute("disabled", "true");
	}
}

//--> ricerca l'ultimo figlio collegato all'item selezionato nella lista 
function findElement(i) {

	var index = 0;
	try {
	 while(index<downloadList.length) {
		  if (downloadList[index].order == i) {
				return index;
		  }
		  index++;
	 }
	} catch (e) {mydump("findElement(): " + e + " - " + index);}
	
	return -1;
}

function findElementById(id) {
	var index = 0;
	try {
		while(index<downloadList.length) {
		  if (downloadList[index].relativeListboxID == id) {
			  return index;
		  }
		  index++;
		}
	} catch (e) {mydump("findElementById(): " + e + " - " + index);}
	
	return -1;
}

//--> attivato dal click su context o toolbar
function pauseResumeReq(pauseReq) {
	var tree = document.getElementById("listDownload0");
	var rangeCount = tree.view.selection.getRangeCount();
	
	for(var i=0; i<rangeCount; i++) {
		 var start = {};
		 var end = {};
		 tree.view.selection.getRangeAt(i,start,end);
		 
		 // ciclo gli elementi selezionati
		 for(var c=start.value; c<=end.value; c++) {
		 
			var lastSon = findElement(c);
			
			if (pauseReq) {
				// se è effettivamente da pausare
				if (
					(!downloadList[lastSon].isCanceled)&&(!downloadList[lastSon].isPaused)&&(!downloadList[lastSon].isCompleted)
					&& (
						((downloadList[lastSon].partialSize != 0)&&(downloadList[lastSon].isResumable))
						||
						(downloadList[lastSon].partialSize == 0)
					)
				) {
					document.getElementById(downloadList[lastSon].relativeListboxID).childNodes[0].childNodes[4].attributes.label.value = strbundle.getString("paused");
					document.getElementById(downloadList[lastSon].relativeListboxID).childNodes[0].childNodes[2].attributes.properties.value = "paused";
					downloadList[lastSon].isPaused = true;
					downloadList[lastSon].setPaused();
					downloadList[lastSon].isRunning = false;
				}
			} else {
				// se è effettivamente da resumare
				if (
					(!downloadList[lastSon].isCanceled)&&(downloadList[lastSon].isPaused)&&(!downloadList[lastSon].isCompleted)
					&& (
						((downloadList[lastSon].partialSize != 0)&&(downloadList[lastSon].isResumable))
						||
						(downloadList[lastSon].partialSize == 0)
					)
				) {
					downloadList[lastSon].isPaused = false;
					Check.haveToCheck = true;	// anche se il numero di download in lista è lo stesso, checkdownloads deve comunque andare ad attivare un nuovo download
					document.getElementById(downloadList[lastSon].relativeListboxID).childNodes[0].childNodes[4].attributes.label.value = strbundle.getString("inqueue");
					document.getElementById(downloadList[lastSon].relativeListboxID).childNodes[0].childNodes[2].attributes.properties.value = "queued";
				} else if (downloadList[lastSon].isCanceled && !downloadList[lastSon].isRunning)
				{
					// è stato cancellato, glielo faccio ripiacere a getfirstfreefile
					downloadList[lastSon].isCanceled=false;
					downloadList[lastSon].isPaused=false;
					downloadList[lastSon].isCompleted=false;
					downloadList[lastSon].isRunning=false;
					downloadList[lastSon].isStarted=false;
					downloadList[lastSon].totalSize = 0;
					downloadList[lastSon].partialSize = 0;
					downloadList[lastSon].compression = false;
					downloadList[lastSon].isPassed = false;
					downloadList[lastSon].numChunks = 0;
					downloadList[lastSon].chunks = new Array();
					downloadList[lastSon].timeLastProgress = 0;
					downloadList[lastSon].timeStart = 0;
					document.getElementById(downloadList[lastSon].relativeListboxID).childNodes[0].childNodes[4].attributes.label.value = strbundle.getString("inqueue");
					Check.haveToCheck = true;
				}
			}
		}
	}
	popup();
}


//--> si occupa di decidere se uno spazio vuoto deve essere scaricato tramite un solo chunk o ri-suddiviso in un massimo di downloadsLeft chunks
function startSubChunks(start, end, firstindex, lastindex, downloadsLeft, relative) {
	var numChunk = downloadsLeft;
	var minSize = 200 * 1024;
	var size = end - start;
	
	if (size <= 2 * minSize || downloadsLeft == 1) {
		// non è possibile eseguire il multipart o il file è troppo piccolo
			downloadChunk(start, end, relative, firstindex);
		
	} else {
		
		// multipart
		if ((size / numChunk) < minSize) {
			// serve un numero inferiore a numChunk di chunks
			numChunk = Math.round(size / minSize);
		}
		
		var stChunkSize = Math.round(size / numChunk);
		
		for (var i = 0; i<(numChunk-1); i++)
			downloadChunk(start + stChunkSize * i, start + (stChunkSize * (i + 1)) - 1, relative, (i==0)?firstindex:(downloadList[relative].chunks.length-1));
		
		downloadChunk(start + stChunkSize * i, end, relative, downloadList[relative].chunks.length-1); // l'ultimo va fino alla fine
		
		// nell'inserimento multiplo l'ultimo deve essere collegato con lastindex
		if (lastindex != -1)
			downloadList[relative].chunks[lastindex].previous = downloadList[relative].chunks.length-1;
	}
}


//--> si occupa di ricercare gli spazi vuoti e chiamare startSubChunks che effettuerà il resume vero e proprio
function resumeThis(index) {
try {
		
		var maxChunks = downloadList[index].maxChunks;
		if (maxChunks == downloadList[index].numChunks) return;
		
		if (downloadList[index].chunks.length == 0) {
			downloadFile(index);
			return;
		}
		
		/*
		mydump("condizione prima:");
		var i = downloadList[index].firstChunk;
		do {
			mydump(downloadList[index].chunks[i].previous + " " + i + ": " + downloadList[index].chunks[i].start + "-" + downloadList[index].chunks[i].end + " " + downloadList[index].chunks[i].next);
			i = downloadList[index].chunks[i].next;
		} while(i != -1);
		*/
		
		// primo pezzettino, deve essere gestito diversamente
		if (downloadList[index].chunks[downloadList[index].firstChunk].start != 0) {
			// inserisco nuovo chunck
			var start = 0;
			var end = downloadList[index].chunks[downloadList[index].firstChunk].start - 1;
			var size = end - start;
			var oldfirst = downloadList[index].firstChunk;
			downloadList[index].firstChunk = downloadList[index].chunks.length;
			startSubChunks(start, end, -1, oldfirst, maxChunks - downloadList[index].numChunks, index);
		}
		
		var i = downloadList[index].firstChunk;
		while (downloadList[index].chunks[i].next != -1) {
				if (downloadList[index].chunks[i].end != downloadList[index].chunks[downloadList[index].chunks[i].next].start - 1) {
					
					// inserisco nuovo chunck
					var start = downloadList[index].chunks[i].end + 1;
					var end = downloadList[index].chunks[downloadList[index].chunks[i].next].start - 1;
					var size = end - start;
					var firstfather = i;
					
					startSubChunks(start, end, firstfather, downloadList[index].chunks[i].next, maxChunks - downloadList[index].numChunks, index);
					
					if (maxChunks == downloadList[index].numChunks)
						break;
				}
			i = downloadList[index].chunks[i].next;
		}
		
		// ultimo pezzettino, deve essere gestito diversamente
		if (maxChunks != downloadList[index].numChunks) {
			if (downloadList[index].chunks[i].end != downloadList[index].totalSize - 1) {
			
				// inserisco nuovo chunck
				var start = downloadList[index].chunks[i].end + 1;
				var end = downloadList[index].totalSize - 1;
				var size = end - start;
				var firstfather = i;
				startSubChunks(start, end, firstfather, -1, maxChunks - downloadList[index].numChunks, index);
			}
		}
		
		downloadList[index].isRunning = true;
		
		/*
		mydump("condizione successiva:");
		i = downloadList[index].firstChunk;
		do {
			mydump(downloadList[index].chunks[i].previous + " " + i + ": " + downloadList[index].chunks[i].start + "-" + downloadList[index].chunks[i].end + " " + downloadList[index].chunks[i].next);
			i = downloadList[index].chunks[i].next;
		} while(i != -1);
		*/
		
	} catch(e) {
		mydump("resumeThis(): " + e + " " + i);
	}
}

//--> determina la dimensione del file in corso di scaricamento
function getFileSize(index) {
try {
	const FileFactory = new Components.Constructor("@mozilla.org/file/local;1", "nsILocalFile", "initWithPath");
	
	if (!(downloadList[index].fileManager.fileSize > 0)) {
		var fileopener = new FileFactory(downloadList[index].dirSave);
		fileopener.append(downloadList[index].destinationName);
		var size = fileopener.fileSize;
		fileopener = null;
		return size;
	} else 
		return downloadList[index].fileManager.fileSize;
} catch (e) {
	mydump("getFileSize(): " + e);
	return 0;
}
}

//--> determina la dimensione del file in corso di scaricamento
function getChunkSize(index, cindex) {
try {
	const FileFactory = new Components.Constructor("@mozilla.org/file/local;1", "nsILocalFile", "initWithPath");
	
	if (!(downloadList[index].chunks[cindex].fileManager.fileSize > 0)) {
	
		if (Prefs.saveInTemp) {
			var fileopener = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("TmpD", Components.interfaces.nsIFile);
			fileopener.append("dta");
		} else 
			var fileopener = new FileFactory(downloadList[index].dirSave);

		fileopener.append(downloadList[index].chunks[cindex].chunkName);

		var size = fileopener.fileSize;
		fileopener = null;
		return size;
	} else 
		return downloadList[index].chunks[cindex].fileManager.fileSize;
} catch (e) {
	return 0;
}
}


//--> attivato dal click su context o toolbar
function cancelPopup() {
	var tree = document.getElementById("listDownload0");
	var rangeCount = tree.view.selection.getRangeCount();
	
	for(var i=rangeCount-1; i>=0; i--) {
		 var start = {};
		 var end = {};
		 tree.view.selection.getRangeAt(i,start,end);
		 
		 // ciclo gli elementi selezionati
		 for(var c=end.value; c>=start.value; c--) {
				var lastSon = findElement(c);
				// se è effettivamente da cancellare
				if ((!downloadList[lastSon].isCanceled) && (!downloadList[lastSon].isCompleted))
					cancelThis(lastSon, "");
		}
	}
}

//--> si occupa della cancellazione di qualsiasi elemento contenuto in downloadList
function cancelThis(index, message) {

	if (!downloadList[index].isCanceled) {
		downloadList[index].isCanceled = true;
		
		if (message == "" || !message)
			message = strbundle.getString("canceled");
			
		// in ogni caso..
		// ..aggiorna la listbox
		document.getElementById(downloadList[index].relativeListboxID).childNodes[0].childNodes[4].attributes.label.value = message;
		document.getElementById(downloadList[index].relativeListboxID).childNodes[0].childNodes[2].attributes.properties.value = "canceled";
		
		if (!downloadList[index].isCompleted) {
			if (downloadList[index].isRunning)
				downloadList[index].setPaused();
			else {
				// ..rimuovi tutti i file relativi ai padri (ricorsiva)
				downloadList[index].isPassed = true;
				downloadList[index].cancelFamily();
			}
		}
		
		if (downloadList[index].isPaused)
			downloadList[index].isPaused = false;
			
		// ..controlla la chiusura
		Check.checkClose();
		popup();
  }
}

function removeFromList(index) {
	if (index < 0) {
		var tree = document.getElementById("listDownload0");
		var start;
		var end;
		var rangeCount = tree.view.selection.getRangeCount();
		for (var i=rangeCount-1; i>=0; i--) {
			 start = {};
			 end = {};
			 tree.view.selection.getRangeAt(i, start, end);
			 for (var c=end.value; c>=start.value; c--) {
				var ind = findElementById(tree.view.getItemAtIndex(c).id);
				setRemoved(ind);
			 }
		}
	} else 
		setRemoved(index);
}

function setRemoved(index) {
	if (!downloadList[index].isCanceled)
		cancelThis(index, "");
	downloadList[index].isRemoved = true;
	downloadList[index].isPaused = false;
	document.getElementById("downfigli").removeChild(document.getElementById(downloadList[index].relativeListboxID));
	mydump("rimuovo dalla lista " + downloadList[index].relativeListboxID);
	downloadList[index].order = -1;
	downloadList[index].relativeListboxID = "";
	downloadList[index].partialSize = 0;
	downloadList[index].totalSize = 0;
	aggiornaIndici(0, document.getElementById("listDownload0").view.rowCount -1);
	Stats.totalDownloads--;
	if (downloadList[index].isCompleted)
		Stats.completedDownloads--;
	downloadList[index].isCompleted = false;
}



function getInfo() {

	var tree = document.getElementById("listDownload0");
	var rangeCount = tree.view.selection.getRangeCount();
	
	for(var i=0; i<rangeCount; i++) {
		 var start = {};
		 var end = {};
		 tree.view.selection.getRangeAt(i,start,end);
		 
		 // ciclo gli elementi selezionati
		 for(var c=start.value; c<=end.value; c++) {
		 
				var lastSon = findElement(c);
				alert(
				  "Get info (only for testing purposes)\n"+
					"URL: " + downloadList[lastSon].url + "\n" +
					"Resumable: " + downloadList[lastSon].isResumable + "\n" +
					"Referrer: " + downloadList[lastSon].refPage.spec + "\n" +
					"Paused: "+ downloadList[lastSon].isPaused + "\n" +
					"Canceled: "+ downloadList[lastSon].isCanceled + "\n" +
					"Completed: "+ downloadList[lastSon].isCompleted + "\n" +
					"Running: "+ downloadList[lastSon].isRunning + "\n" +
					"Started: "+ downloadList[lastSon].isStarted + "\n" +
					"PartialSize: " + downloadList[lastSon].partialSize + "\n" +
					"Passed: " + downloadList[lastSon].isPassed + "\n" +
					"Dirsave: " + downloadList[lastSon].dirSave + "\n" +
					"Destination Name: " + downloadList[lastSon].destinationName
				);
		 }
	}
}

//--> Richiamata dal context, muove la selezione corrente in cima o al fondo della tree
function moveTop(top) {
	var tree = document.getElementById("listDownload0");
	var start;
	var end;
	var idList = new Array();
	var rangeCount = tree.view.selection.getRangeCount();

	for (var i=0; i<rangeCount; i++) {
		 start = {};
		 end = {};
		 tree.view.selection.getRangeAt(i, start, end);
		 for (var c=start.value; c<=end.value; c++) {
			idList.push(tree.view.getItemAtIndex(c).id);
		 }
	}
	
	if (top) {
		var first = tree.view.getItemAtIndex(0).id;
		var fine = downloadList[findElementById(idList[idList.length - 1])].order;
		for (var i=0; i<idList.length; i++) {
			document.getElementById("downfigli").insertBefore(document.getElementById(idList[i]), document.getElementById(first));
			tree.view.selection.rangedSelect(i, i, true);
		}
		aggiornaIndici(0, fine);
	} else {
		var first = tree.view.getItemAtIndex(0).id;
		var inizio = downloadList[findElementById(idList[0])].order;
		for (var i=0; i<idList.length; i++) {
			var elem = document.getElementById(idList[i]).cloneNode(true);
			 document.getElementById("downfigli").removeChild(document.getElementById(idList[i]));
			 document.getElementById("downfigli").appendChild(elem);
			 tree.view.selection.rangedSelect(tree.view.rowCount-1, tree.view.rowCount-1, true);
		}
		aggiornaIndici(inizio, tree.view.rowCount -1);
	}

}

//--> Richiamata dal context, muove di n posizioni la selezione corrente
//      pos < 0 equivale a spostare verso l'alto di n posizioni
function move(pos) {
	var tree = document.getElementById("listDownload0");
	var start;
	var end;
	var idList = new Array();
	var rangeCount = tree.view.selection.getRangeCount();
	
	for (var i=0; i<rangeCount; i++) {
		 start = {};
		 end = {};
		 tree.view.selection.getRangeAt(i, start, end);
		 for (var c=start.value; c<=end.value; c++) {
			idList.push(tree.view.getItemAtIndex(c).id);
		 }
	}

	if (pos < 0) {
		for (var i=0; i<idList.length; i++) {
		  var xx = findElementById(idList[i]);
		  if (downloadList[xx].order + pos < 0)
				break;
			var before = tree.view.getItemAtIndex(downloadList[xx].order + pos).id;
			document.getElementById("downfigli").insertBefore(document.getElementById(idList[i]), document.getElementById(before));
			tree.view.selection.rangedSelect(downloadList[xx].order + pos, downloadList[xx].order + pos, true);
			aggiornaIndici(downloadList[xx].order + pos, downloadList[xx].order);
		}
	} else {
		for (var i=idList.length-1; i>=0; i--) {
			var xx = findElementById(idList[i]);
			if (downloadList[xx].order + pos + 1 > tree.view.rowCount) 
				break;
		  if ((downloadList[xx].order + pos + 1) < tree.view.rowCount) {
				var before = tree.view.getItemAtIndex(downloadList[xx].order + pos + 1).id;
				document.getElementById("downfigli").insertBefore(document.getElementById(idList[i]), document.getElementById(before));
				tree.view.selection.rangedSelect(downloadList[xx].order + pos, downloadList[xx].order + pos, true);
				aggiornaIndici(downloadList[xx].order, downloadList[xx].order + pos + 1);
			} else {
				var elem = document.getElementById(idList[i]).cloneNode(true);
				document.getElementById("downfigli").removeChild(document.getElementById(idList[i]));
				document.getElementById("downfigli").appendChild(elem);
				tree.view.selection.rangedSelect(tree.view.rowCount-1, tree.view.rowCount-1, true);
				aggiornaIndici(downloadList[xx].order, tree.view.rowCount - 1);
			}
		}
	}

}

//--> Si occupa di sincronizzare l'ordine attuale degli elementi in tree con la proprietà order della downloadList, giocando sull'id dei treeitem che non cambiano mai
//      Per evitare di ciclare tutte le volte tutti gli elementi, si indica l'inizio e fine della sincronizzazione
function aggiornaIndici(inizio, fine) {
	var tree = document.getElementById("listDownload0");
	for (var i=inizio; i<=fine; i++) {
		var id = tree.view.getItemAtIndex(i).id;
		//alert("numero " + i + " " + id);
		for (var x = 0; x<downloadList.length; x++) 
			if (downloadList[x].relativeListboxID == id) {
				//alert("downloadList[" + x + "].order = " + i);
				downloadList[x].order = i;
				break;
			}
	}
}

//--> Richiamata dal context, apre la directory target
function openFolder() {
  var tree = document.getElementById("listDownload0");
	var rangeCount = tree.view.selection.getRangeCount();
	
	for(var i=0; i<rangeCount; i++) {
		 var start = {};
		 var end = {};
		 tree.view.selection.getRangeAt(i,start,end);
		 
		 // ciclo gli elementi selezionati
		 for(var c=start.value; c<=end.value; c++) {
		 
			var lastSon = findElement(c);
			
			if (downloadList[lastSon].isCompleted) {
				var dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				try {
				    dir.initWithPath(downloadList[lastSon].dirSave);
				    dir.launch();
				} catch (e){alert(strbundle.getString("noFolder"));}
			}
    }
    } 
}

//--> Richiamata dal doppio click, apre il file
function openFile(event) {
	var lastSon = findElement(document.getElementById("listDownload0").currentIndex);
	if (downloadList[lastSon].isCompleted) {
		var dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		try {
				dir.initWithPath(downloadList[lastSon].dirSave + downloadList[lastSon].destinationName);
				dir.launch();
		} catch (e){}
	}
}


//--> Richiamata dal context, seleziona tutto
function selectAll() {
		var tree = document.getElementById("listDownload0");
		tree.view.selection.selectAll();
}

//--> Richiamata dal context, inverte la selezione
function selectInv() {
	var tree = document.getElementById("listDownload0");
	for (var x = 0; x<tree.view.rowCount; x++) {
		if (tree.view.selection.isSelected(x))
			tree.view.selection.toggleSelect(x);
		else
			tree.view.selection.rangedSelect(x, x, true);
	}
}

//--> Richiamata dal context, aumenta o diminuisce di uno il numero di chunks
function addChunk(add) {
	var tree = document.getElementById("listDownload0");
	var rangeCount = tree.view.selection.getRangeCount();
	
	for(var i=0; i<rangeCount; i++) {
		 var start = {};
		 var end = {};
		 tree.view.selection.getRangeAt(i,start,end);
		 
		 // ciclo gli elementi selezionati
		 for(var c=start.value; c<=end.value; c++) {
		 
			var index = findElement(c);
			
			if (!add && downloadList[index].maxChunks > 2) {
				--downloadList[index].maxChunks;
				if (downloadList[index].isRunning) 
					for (var i = 0; i<downloadList[index].chunks.length; i++)
						if (downloadList[index].chunks[i].isRunning) {
							downloadList[index].chunks[i].progressPersist.cancelSave();
							break;
						}
			} else if (add && downloadList[index].maxChunks < 10) {
				++downloadList[index].maxChunks;
				if (downloadList[index].isRunning)
					for (var i = 0; i<downloadList[index].chunks.length; i++)
						if (downloadList[index].chunks[i].isRunning) {
							downloadList[index].chunks[i].progressPersist.cancelSave();
						}
			}
			
			document.getElementById(downloadList[index].relativeListboxID).childNodes[0].childNodes[5].attributes.label.value = downloadList[index].numChunks + "/" + downloadList[index].maxChunks;
		}
	}
}

function addFinalSlash(subdir) {
	if (subdir.substr(subdir.length - 1, 1) == findSeparator()) 
		subdir = subdir.substring(0, subdir.length - 1);
	return subdir + findSeparator();
}

function saveSession() {
try {
	var doc = document.implementation.createDocument("", "", null);
	var list = doc.createElement("downloads");
	
	for (var i = 0; i < downloadList.length; i++) {
		if (!downloadList[i].isRemoved && ((Prefs.onClosingSaveCompleted && downloadList[i].isCompleted) || (Prefs.onClosingSaveCanceled && downloadList[i].isCanceled) || downloadList[i].isPaused || downloadList[i].setIsRunning())) {
			
			var download = doc.createElement("download");
			download.setAttribute("url", downloadList[i].url);
			download.setAttribute("dirsave", addFinalSlash(downloadList[i].dirSave));
			download.setAttribute("filename", downloadList[i].fileName);
			download.setAttribute("destname", downloadList[i].destinationName);
			download.setAttribute("istance", downloadList[i].numIstance);
			download.setAttribute("description", downloadList[i].description);
			download.setAttribute("referrer", downloadList[i].refPage.spec);
			download.setAttribute("resumable", downloadList[i].isResumable);
			download.setAttribute("maskedName", downloadList[i].alreadyMaskedName);
			download.setAttribute("maskedDir", downloadList[i].alreadyMaskedDir);
			
			if (!downloadList[i].isResumable && !downloadList[i].isCompleted) {
				download.setAttribute("partialsize", 0);
				download.setAttribute("totalsize", 0);
			} else {
				download.setAttribute("partialsize", downloadList[i].partialSize);
				download.setAttribute("totalsize", downloadList[i].totalSize);
			}
			
			download.setAttribute("completed", downloadList[i].isCompleted);
			download.setAttribute("canceled", downloadList[i].isCanceled);
			
			if (!downloadList[i].isCompleted && !downloadList[i].isCanceled && downloadList[i].chunks.length > 0) {
				var x = downloadList[i].firstChunk;
				do {
					if (downloadList[i].chunks[x].chunkSize != 0 && downloadList[i].isResumable) {
					var chunk = doc.createElement("chunk");
					chunk.setAttribute("path", downloadList[i].chunks[x].fileManager.path);
					chunk.setAttribute("start", downloadList[i].chunks[x].start);
					chunk.setAttribute("end", downloadList[i].chunks[x].end);
					chunk.setAttribute("size", downloadList[i].chunks[x].chunkSize);
					download.appendChild(chunk);
					} else if (downloadList[i].chunks[x].fileManager.exists()) {
						try {
							downloadList[i].chunks[x].fileManager.remove(false);
						} catch(e) {}
					}
					x = downloadList[i].chunks[x].next;
				} while(x != -1);
			}
			
			list.appendChild(download);
		}
	}
	
	doc.appendChild(list);
	var serializer = new XMLSerializer();
	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
	var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile); // get profile folder
	file.append("extensions");
	file.append("{DDC359D1-844A-42a7-9AA1-88A850A938A8}");
	file.append("history.xml");
	foStream.init(file, 0x02 | 0x08 | 0x20, 0664, 0);   // write, create, truncate
	serializer.serializeToStream(doc, foStream, "");   // rememeber, doc is the DOM tree
	foStream.close();
	
} catch(e) {
		mydump("saveSession(): " + e);
}
}

function loadSession() {
try {
		const FileFactory = new Components.Constructor("@mozilla.org/file/local;1", "nsILocalFile", "initWithPath");
		var file = Components.classes['@mozilla.org/file/directory_service;1'].createInstance(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
		file.append("extensions");
		file.append("{DDC359D1-844A-42a7-9AA1-88A850A938A8}");
		file.append("history.xml");

		if (!file.exists()) return;
		
		var data = new String();
		var fiStream = Components.classes['@mozilla.org/network/file-input-stream;1'].createInstance(Components.interfaces.nsIFileInputStream);
		var siStream = Components.classes['@mozilla.org/scriptableinputstream;1'].createInstance(Components.interfaces.nsIScriptableInputStream);
		fiStream.init(file, 1, 0, false);
		siStream.init(fiStream);
		data += siStream.read(-1);
		siStream.close();
		fiStream.close();

		
		var fileContents = data;
		var domParser = new DOMParser();
		var doc = domParser.parseFromString(fileContents, "text/xml");
		var list = doc.documentElement;
		for (var i = 0; i < list.childNodes.length; i++) {
		
			var down = list.childNodes[i];
			var index = downloadList.length;
			
			if (
					(Prefs.onClosingSaveCompleted && down.getAttribute("completed")=="true") || 
					(Prefs.onClosingSaveCanceled && down.getAttribute("canceled")=="true") || 
					(down.getAttribute("canceled")=="false" && down.getAttribute("completed")=="false")
				) {
				
				downloadList[index] = new downloadElement(down.getAttribute("url"), down.getAttribute("filename"), down.getAttribute("dirsave"), down.getAttribute("istance"), index, down.getAttribute("description"));
				downloadList[index].refPage = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
				downloadList[index].refPage.spec = down.getAttribute("referrer");
				downloadList[index].destinationName = down.getAttribute("destname");
				downloadList[index].isResumable = down.getAttribute("resumable")=="true" ? true: false;
				downloadList[index].isCanceled = down.getAttribute("canceled")=="true" ? true: false;
				downloadList[index].isCompleted = down.getAttribute("completed")=="true" ? true: false;
				downloadList[index].partialSize = parseInt(down.getAttribute("partialsize"));
				downloadList[index].totalSize = parseInt(down.getAttribute("totalsize"));
				downloadList[index].relativeListboxID = "down" + index;
				downloadList[index].alreadyMaskedName = down.getAttribute("maskedName")=="true" ? true: false;
				downloadList[index].alreadyMaskedDir = down.getAttribute("maskedDir")=="true" ? true: false;
				
				if (downloadList[index].partialSize == 0) 
					downloadList[index].isStarted = false;
				else
					downloadList[index].isStarted = true;
				
				if (!downloadList[index].isCanceled && !downloadList[index].isCompleted) {
					
					downloadList[index].isPaused = true;
					reCreateFile(index);
					
					for (var x = 0; x < down.childNodes.length; x++) {
						var chunkEl = down.childNodes[x];
						
						var test = new FileFactory(chunkEl.getAttribute("path"));
						
						if (test.exists()) {
							var chunkIndex = downloadList[index].chunks.length;
							downloadList[index].chunks.push(new chunk(parseInt(chunkEl.getAttribute("start")), parseInt(chunkEl.getAttribute("start")) + test.fileSize - 1, index));
							downloadList[index].chunks[chunkIndex].isRunning = false;
							downloadList[index].chunks[chunkIndex].chunkSize = parseInt(chunkEl.getAttribute("size"));
							
							if (x == 0)
								downloadList[index].chunks[chunkIndex].previous = -1;
							else
								downloadList[index].chunks[chunkIndex].previous = chunkIndex - 1;
								
							if (x == down.childNodes.length - 1)
								downloadList[index].chunks[chunkIndex].next = -1;
							else
								downloadList[index].chunks[chunkIndex].next = chunkIndex + 1;	
							
							downloadList[index].chunks[chunkIndex].fileManager = test;
						}
					}
					downloadList[index].setPartialSize();

				} else if (downloadList[index].isCompleted) {
						downloadList[index].fileManager = new FileFactory(downloadList[index].dirSave);
						downloadList[index].fileManager.append(downloadList[index].destinationName);
						downloadList[index].dirSave = downloadList[index].dirSave;
						Stats.completedDownloads++;
						downloadList[index].isPassed = true;
				} else if (downloadList[index].isCanceled)
					downloadList[index].isPassed = true;
				
				Stats.totalDownloads++;
				populateListbox(index);
			}
		}
		
		var sum = 0;
		for (var i = 0; i < downloadList.length; i++)
			sum = sum + downloadList[i].partialSize;   // somma i contributi solo dei download attivi al momento

		Stats.downloadedBytes = sum;
		Check.lastCheck = Stats.downloadedBytes;
} catch(e) {
	mydump("loadSession(): " + e);
}
}

function reCreateFile(index) {
	
	const FileFactory = new Components.Constructor("@mozilla.org/file/local;1", "nsILocalFile", "initWithPath");
try {

	//downloadList[index].destinationName = downloadList[index].fileName;
	if (!downloadList[index].alreadyMaskedName) {
		var filename = toggleInvalidChar(makeReplacement(getPreference("extensions.dta.rename.files", "*name*.*ext*"), downloadList[index])).replace(/\//g, "");
		downloadList[index].alreadyMaskedName = true;
		downloadList[index].destinationName = filename;
		downloadList[index].destinationName = renameFile(downloadList[index].dirSave, downloadList[index].destinationName, index);
	}
	
	if (!downloadList[index].alreadyMaskedDir) {
		var subdir = toggleInvalidChar(makeReplacement(getPreference("extensions.dta.rename.dir", ""), downloadList[index])).replace(/(\\){2,}/g, "\\").replace(/(\/){2,}/g, "/").replace(/\\/g, findSeparator()).replace(/\//g, findSeparator());
		downloadList[index].alreadyMaskedDir = true;
	
		var separator = findSeparator();
		
		// ciocchi per uniformità di slash
		if (subdir.substring(0,1) == separator) subdir = subdir.substring(1, subdir.length);
		if (subdir.substr(subdir.length - 1, 1) == separator) subdir = subdir.substring(0, subdir.length - 1);
		
		// aggiungo alla dirSave le sottodirectory
		if (subdir.length>0)
			downloadList[index].dirSave = (downloadList[index].dirSave + subdir.replace(/\//g, separator) + separator).replace(/(\\){2,}/g, "\\").replace(/(\/){2,}/g, "/");
		else
			downloadList[index].dirSave = downloadList[index].dirSave.replace(/(\\){2,}/g, "\\").replace(/(\/){2,}/g, "/");
	}
	
	checkFilenames("reCreateFile", downloadList[index]);
	
	downloadList[index].fileManager = new FileFactory(downloadList[index].dirSave);
	downloadList[index].fileManager.append(downloadList[index].destinationName); 
	
	var numChunk = downloadList[index].maxChunks;

}catch(e) {
	mydump("reCreateFile(): " + e);
}
}

function saveLog() {

	if (logtext == "") 
		return;
	
	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);	
	var log = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile); // get profile folder
	log.append("extensions");
	log.append("{DDC359D1-844A-42a7-9AA1-88A850A938A8}");
	log.append("log.txt");
	
	try {
		// se i log precedenti superano i 100Kb, cancelliamo il file
		if (log.fileSize > (100 * 1024))
			log.remove(false);
	} catch(e) {}
	
	var time = new Date();
	var hours = time.getHours();
	var minutes = time.getMinutes();
	minutes=((minutes < 10) ? "0" : "") + minutes;
	var seconds = time.getSeconds();
	seconds=((seconds < 10) ? "0" : "") + seconds;
	var clock = time.getDate() + "/" + time.getMonth() + "/" + time.getFullYear() + " - " + hours + ":" + minutes + ":" + seconds;
	
	foStream.init(log, 0x04 | 0x08 | 0x10, 0664, 0); // append

	logtext = "--------------------\n" + clock + "\n--------------------\n\n" + logtext + "\n\n";
	foStream.write(logtext, logtext.length);
	foStream.close();
	
	logtext = "";
}