function makeRegex() {
	
	filtro = document.getElementById("filter");
	
	if (document.getElementById("regex").checked) {
	
		if (filtro.value.substring(0,1) != "/") filtro.value = "/" + filtro.value;
		if (filtro.value.substr(filtro.value.length - 1, 1) != "/") filtro.value = filtro.value + "/";
	
	} else {
	
		if (filtro.value.substring(0,1) == "/") filtro.value = filtro.value.substring(1, filtro.value.length);
		if (filtro.value.substr(filtro.value.length - 1, 1) == "/") filtro.value = filtro.value.substring(0, filtro.value.length -1);
	}
}

function createFilter() {
	var filtertxt = "";
	
	if (!document.getElementById("regexbox").hidden) {
		var filtertxt = document.getElementById("filter").value;
		if (filtertxt.substring(0,1) == "/" && filtertxt.substr(filtertxt.length - 1, 1) == "/" && filtertxt.length > 1)
			document.getElementById("regex").checked = true; else document.getElementById("regex").setAttribute("checked", false);
	}
	
	var filtro = new Array(); var fil; var arr;
	for (var i = 0; i < document.getElementById("checkcontainer").childNodes.length; i++) {
		if (document.getElementById("checkcontainer").childNodes[i].checked) 
			filtro = convertFilter(pref.getCharPref("extensions.dta.context." + document.getElementById("checkcontainer").childNodes[i].getAttribute("id") + ".filter"), filtro);
	}
	
	if (filtertxt.replace(/^\s*|\s*$/gi,"") != "")
		filtro = convertFilter(filtertxt.replace(/^\s*|\s*$/gi,""), filtro);
	
	return filtro;
}

function convertFilter (fil, filtro) {

	if (fil.substring(0,1) == "/" && fil.substring(fil.length - 1, fil.length) == "/") {
		
		if (fil.substring(1, fil.length - 1).replace(/^\s*|\s*$/gi,"") != "") 
			filtro[ filtro.length ] = fil.substring(1, fil.length - 1).replace(/^\s*|\s*$/gi,"");
	
	} else {
		
		fil = fil.replace(/\./gi, "\\.");
		fil = fil.replace(/\*/gi, "(.)*");
		fil = fil.replace(/\$/gi, "\\$");
		fil = fil.replace(/\^/gi, "\\^");
		fil = fil.replace(/\+/gi, "\\+");
		fil = fil.replace(/\?/gi, ".");
		fil = fil.replace(/\|/gi, "\\|");
		fil = fil.replace(/\[/gi, "\\[");

		arr = fil.split(",");
		
		for ( var index in arr ) {
			if (arr[ index ].replace(/^\s*|\s*$/gi,"") != "") filtro[ filtro.length ] = arr[ index ].replace(/^\s*|\s*$/gi,"");
		}
	}
	
	return filtro;
}

function changeTab() {

	var filter = document.getElementById("filter");
	var numfilter = pref.getIntPref("extensions.dta.context.numfilters");
	
	pref.setIntPref("extensions.dta.context.seltab", document.getElementById("tab").selectedIndex);

	var box = document.getElementById("checkcontainer");
	
	while (box.hasChildNodes())
		box.removeChild(box.lastChild);
	
	var numfilter = getPreference("extensions.dta.context.numfilters", defNumFilters);

	if (document.getElementById("fileTab").selected == true) {
		for (var i = 0; i < numfilter; i++) 
			if (pref.getBoolPref("extensions.dta.context.filter" + i + ".isLinkFilter"))
				addCheckbox(pref.getCharPref("extensions.dta.context.filter" + i + ".caption"),"filter" + i, pref.getBoolPref("extensions.dta.context.filter" + i + ".checked"));

	} else {
		for (var i = 0; i < numfilter; i++) 
			if (pref.getBoolPref("extensions.dta.context.filter" + i + ".isImageFilter"))
				addCheckbox(pref.getCharPref("extensions.dta.context.filter" + i + ".caption"),"filter" + i, pref.getBoolPref("extensions.dta.context.filter" + i + ".checked"));
	}
}

function checkAll() {

	if (document.getElementById("fileTab").selected == true)
		check("fileList");
	else
		check("imgList");
}

function check(name) {

	var occur;
	var filter = createFilter();
	var list = document.getElementById(name);
	var reg;
	var nume, ind;
	var elemento;
	var sel = 0;
	var colori = new Array("#FEFFAF", "#FFD7D7", "#DFDFFF", "#C7FFC9", "#C7F0FF", "#FFE397", "#C7FFD4");
	var highli = getPreference("extensions.dta.context.highlight", true);
	
	// checks all the items that passes the filtering
	for (var i = 0; i < list.getRowCount(); i++) {
	
		var tmp = list.getItemAtIndex(i);
		var li = tmp.getAttribute("value");
		nume = 0; ind = -1; 
		
		for (var x = 0; x < filter.length; ++x) {
			reg = new RegExp(filter[x], "i");
			if (li.match(reg)) {nume = 1; ind = x; break};
		}
		
		if (nume > 0) {
			sel++;
			tmp.setAttribute("checked", true); 
			tmp.childNodes[0].attributes.checked.value = true;
			
			if (highli)
				if (ind<8)
					tmp.setAttribute("style", "background-color: " + colori[ind] + ";");
				else
					tmp.setAttribute("style", "background-color: #FEFFAF;");
					
		} else {
			tmp.setAttribute("checked", false);
			tmp.childNodes[0].attributes.checked.value = false;
			tmp.removeAttribute("style");
		}
	}

	savepref();
	if (sel > 0) 
		document.getElementById("status").label = strbundle.getString("selel") + " " + sel + " " + strbundle.getString("of") + " " + document.getElementById(name).getRowCount();
	else
		document.getElementById("status").label = strbundle.getString("status");

}

	
function showFilter() {
	var reg = document.getElementById("regexbox");
	var freccia = document.getElementById("freccia");
	
	if (arguments.length == 0) reg.hidden= !(reg.hidden); else reg.hidden = !(arguments[0]);
	if (reg.hidden) freccia.src="chrome://dta/content/immagini/downup.png"; else freccia.src="chrome://dta/content/immagini/down.png";
}

function addCheckbox (caption, id, checked) {
	var box = document.getElementById("checkcontainer");
	var checkbox = document.createElement("checkbox");
	checkbox.setAttribute("checked", checked);
	checkbox.setAttribute("id", id);
	checkbox.setAttribute("label", caption);
	checkbox.setAttribute("class", "lista");
	checkbox.setAttribute("oncommand", "savepref();checkAll();");
	box.appendChild(checkbox);
}

function checkItem() {
	var higli;
	try { highli = pref.getBoolPref("extensions.dta.context.highlight"); } catch(e) { highli = true; }
	
	if (document.getElementById("fileTab").selected) 
		var name = "fileList"; 
	else if (document.getElementById("imgTab").selected)
		var name = "imgList";
    else var name = "depthList";

	for (var i = 0; i < document.getElementById(name).selectedCount; i++) {
		var elemento = document.getElementById(name).getSelectedItem(i);
		elemento.childNodes[0].attributes.checked.value = elemento.checked;
		
		if (elemento.checked && highli) elemento.setAttribute("style", "background-color: #FEFFAF; color: black;"); 
		else elemento.removeAttribute("style"); 
	}
	
	var sel = 0;
	for (var i = 0; i < document.getElementById(name).getRowCount(); i++) {
		if (document.getElementById(name).getItemAtIndex(i).getAttribute("checked") == "true") sel++; 
	}
	
	
	if (sel > 0) 
		document.getElementById("status").label = strbundle.getString("selel") + " " + sel + " " + strbundle.getString("of") + " " + document.getElementById(name).getRowCount();
	else
		document.getElementById("status").label = strbundle.getString("status");
	
}